<%@language="VBScript"%>
<% option explicit %>
<html><head><title>Demo-interface to Script2Script.dll.</title>
<style>
a  { text-decoration:none; }
</style>
</head><body bgcolor=#aaccdd><pre>

<% 'procedures: read_file, rw, re, rwe are used from this include: %>
<!--#include file="custom.inc"-->
<%

dim source_text, schema_name, schema_text
dim result
dim url_path
dim class_name, tstObj, which_dll, which_object
dim path_to_examples_folder
dim appl_folder_path
dim wi, ws
dim bottom_seconds
dim seconds_per_kilobyte
dim text_size_limit


'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
'  Set:
'     case where this scriipt runs on Windows or NT, 
'     script parameters.
'===============================================================================
dim NTorWindows
NTorWindows = "N"  

Select Case NTorWindows
  Case "W" 
     appl_folder_path = "c:\d\Script2Script"               
     bottom_seconds = 30
     seconds_per_kilobyte = 30. 'double
     text_size_limit = 100000   'bytes
  Case "N"
     appl_folder_path = "c:\Program Files\Script2Script22"  
     bottom_seconds = 30
     seconds_per_kilobyte = 5. 'double
     text_size_limit = 30000   'bytes
end select
'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

path_to_examples_folder = appl_folder_path & "\Examples"


'to function correctly, Compi needs path to support include-actions
url_path = request.ServerVariables("path_info") 


'UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
'  Data from User.
'==================================================================

dim display_file, display_file_abs
display_file = remove_spacers(Request.QueryString("file"))

if "" <> display_file then
   'acces only Examples folder:
   if instr(display_file, "..") > 0 then  rwe "File not found."

   display_file_abs = path_to_examples_folder & "\" & display_file
   ws = trim(read_file ( display_file_abs ))
   if "" = ws then
      rwe "File " & display_file_abs & " is not found or empty."
   else
      rwe Server.HTMLEncode(ws)
   end if
end if

dim display_example
dim display_example_abs
dim displayed_example
dim path_to_tests
display_example_abs = "" 'use as flag
path_to_tests = "\asp2php\asp_samples\tests"
display_example = remove_spacers(Request.QueryString("files"))
if "" <> display_example then
   'acces only Examples folder:
   if instr(display_example, "..") = 0 then  
      display_example_abs = path_to_examples_folder & "\" & _
                            path_to_tests & "\" & display_example
      displayed_example = _
               Server.HTMLEncode((read_file(display_example_abs )))
   end if
end if
'UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU


'HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
' Make HTML part visible for User
'==================================================================

%>
  <b>Partially convert ASP to PHP</b>
  <form name="only" action="<%=url_path%>" method="post">
  "Partially" applies all restrictions and interpretations in <a href="<%=url_path%>?file=asp2php\readme.txt">readme</a>.
  Enter or copy-paste the ASP-code below. File size limit is <%
    rw cstr(text_size_limit/1000)%>K.
  
  <textarea name="source" rows=15 cols=90><%=displayed_example%></textarea><br>
  <% 
  if "" <> display_example then
     rw "File " & display_example & " has been selected."
  end if
  %>

  <input type="submit" value="Convert" />
  
  Prebuilt examples can be selected for conversion:
<% rw replace(vbcrlf & ShowFileQueries(path_to_examples_folder & _
      path_to_tests), vbcrlf, vbcrlf & "    " )%>

  </form>

<%   
'HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH



'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' I N P U T     D A T A 
'==========================================================================
dim debug_request_now
debug_request_now = false
'--------------------------------------------------------------------------

source_text = left(request.form ( "source" ), text_size_limit)
if source_text = "" then rwe "</pre></body></html>"


dim script_time_limit
'adjust coefficients according your server speed:
'this property units are seconds:
Server.ScriptTimeout = clng(bottom_seconds + _
                       (len(source_text) /1000.) * seconds_per_kilobyte)

schema_name = path_to_examples_folder & "\asp2php\main.txt"
schema_name = replace(schema_name,"/","\")
schema_text = read_file ( schema_name )
if schema_text = "" then rwe "empty schema file `" & schema_name & "` ... "
 
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
 



'DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
'   D L L   I N T E R F A C E   I S   W R I T T E N   B E L O W
'==================================================================


'------------------------------------------------------------------

  'DEBUGGING: 
  'To troubleshoot dll-interface problems, 
  'or to learn how this asp-page works,
  'variable "debug_dll_operations" can be set to True:
  
  dim debug_dll_operations
  debug_dll_operations = true
'------------------------------------------------------------------

'==================================================================
' This is a vital step: names must be chosen correctly:

  '**************************************
  'this is dll-project-name:
  which_dll = "S2S_Compi"  
  '"Script2Script" - this won't work.
  '**************************************

  '**************************************
  class_name = "sscomp"
  '**************************************

  which_object = which_dll & "." & class_name
'==================================================================

'==================================================================
' Create Script2Script:
'------------------------------------------------------------------
 on error resume next
 set tstObj = Server.CreateObject(which_object)  
 if err.number > 0 then 
    rw "creatting object " & which_object & " dll exception: " & _
       err.number & " " & err.description
    err.clear
 else
    if debug_dll_operations then rw _
       "<br>dll object created succesfully<br>"
 end if
'==================================================================


'==================================================================
' Constant "W" and object "response" have to be 
' submitted to Compi to let him know that
' he works in web environment and not in desktop environment.
'------------------------------------------------------------------
dim dummy_variable_to_feed_dll_interface
set dummy_variable_to_feed_dll_interface = response


tstObj.give_write_method dummy_variable_to_feed_dll_interface, "W"  
'header is: sscom.give_write_method pout, ".."
if err > 0 then 
    rw  "<br>dll exception when ""giving"" reference to " & _ 
        """response"" object:" & _
        err.number & " " & err.description
    err.clear

    rw  "<br>response object name is:`" & _         
        cstr(dummy_variable_to_feed_dll_interface) & "` " 
    if err > 0 then
       rw "<br>Why this is an error:" & err & " " & err.description
    end if
    err.clear
else
    if debug_dll_operations then rw  _
       "<br>write method key W given successfully<br>"
end if
'==================================================================


'=========================================================================
' If you have registered version of Script2Script, you can submit
' path where the registration.txt file is resided:
'-------------------------------------------------------------------------
  tstObj.Give_Registration_Folder_Path appl_folder_path
  if err.number > 0 then 
    rw  "<br>dll exception when submmitting registration folder path.: " _
        & err.number & " " &err.description
    err.clear
  else
    if debug_dll_operations then rw  _
       "<br>Registration folder path is submitted " & _
       "for execution succesfully.<br>"
  end if
'=========================================================================
rw "<font color=0000aa>"



'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
'  Submitting Schema and Source to dll.
'  The effect will be the same as for GUI menu/Run. 
'  Result will be in variable: result.
'-------------------------------------------------------------------------


    '=====================================================================
    ' Submitting schema to dll.
    '---------------------------------------------------------------------
     dim sc_MasterName, ReadSourceFromDisk, WriteResultsToDisk

     sc_MasterName = schema_name
        'Server.Mappath(".") & "\" & schema_name
     ReadSourceFromDisk = "N"
     WriteResultsToDisk = "N"

     tstObj.Go sc_MasterName, schema_text, ReadSourceFromDisk, _
               WriteResultsToDisk

     if err.number > 0 then 
         rw  "<br>dll exception of submitting schema for execution: " _
             & err.number & " " &err.description
         err.clear
     else
         if debug_dll_operations then rw  _
            "<br>schema submitted for execution succesfully.<br>"
     end if

     '----------------------------
     result = tstObj.GetResultText
     '----------------------------


     '====================================================================
     ' Submitting source to dll.
     '--------------------------------------------------------------------
     dim so_MasterName

     if "" = display_example_abs then
        'some schemas may need source file extension:
        'display_example_abs = path_to_examples_folder & "\" & _
        '          path_to_tests & "\" & "generic.asp"
        display_example_abs = "x:\x\text_from_screen.asp"
     end if

     so_MasterName = display_example_abs
        'Server.Mappath(".") & "\" & file_to_read
     ReadSourceFromDisk = "N"
     WriteResultsToDisk = "N"

     tstObj.Go so_MasterName, source_text, _
               ReadSourceFromDisk, WriteResultsToDisk

     if err.number > 0 then 
        rw  "<br>dll exception of submitting source for execution: " & _
             err.number & " " & err.description
        err.clear
     else
        if debug_dll_operations then rw  _
           "<br>source submitted for execution succesfully.<br>"
     end if

     '----------------------------
     result = tstObj.GetResultText
     '----------------------------

'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm




'==========================================================================
if err.number > 0 then 
   rw  "<br>Exception happened during dll execution: " & _
       err.number & " " &  err.description
   err.clear
else
   if debug_dll_operations then rw  _
      "<br>result text taken successfully.<br>"
end if
'==========================================================================




rw "</font><br><br>RESULT:</br><br><font color=444400>" 
rw result
rw "</font></pre></body></html>"

set tstObj = nothing
response.end
'dddddddddddddddddddddddDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
%>