VERSION 4.00
Begin VB.Form web_frmConsole 
   Caption         =   "Help"
   ClientHeight    =   5085
   ClientLeft      =   2250
   ClientTop       =   3765
   ClientWidth     =   8700
   Height          =   5490
   Icon            =   "web_frmConsole.frx":0000
   Left            =   2190
   LinkTopic       =   "Form1"
   ScaleHeight     =   5085
   ScaleWidth      =   8700
   Top             =   3420
   Width           =   8820
   Begin VB.TextBox txtHelp 
      BackColor       =   &H00C0C0C0&
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4815
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   120
      Width           =   8415
   End
End
Attribute VB_Name = "web_frmConsole"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

' Added module to trace and debug dll at
' startup or from Web browser.

Option Explicit

Private ve$
Private vr$
Private vl$

Public IAmLoaded$

'set limit here:
Const mConsole_Text_Limit& = 20000
'set file name here:
Const mConsoleFileName$ = "web_console.txt"

Private mConsoleAbsPath$

' Trace is set in webInterface.Class_Initialize:
Private mTraceApplication As Boolean

Private Declare Function GetTickCount Lib "kernel32" () As Long



'INPU  windows_mode = vbNormal, vbMaximized, ...
'USE   not used as of July 15, 2003
'
Public Sub DisplayText( _
       WText$, _
       WCaption$, _
       windows_mode&, _
       bcolor&, _
       Locked$)
 
 On Error Resume Next
 Me.Caption = WCaption
 If "U" = UCase(Left(Locked, 1)) Then
     txtHelp.Locked = False
 Else
     txtHelp.Locked = True
 End If
 txtHelp.BackColor = bcolor
 txtHelp.Text = WText
 Me.WindowState = windows_mode

End Sub

'EXCE free
'
' simple console display
' refreshed after mConsole_Text_Limit
' does not save to a file;
'      assumes that data is saved separately;
'
' input: s$ - source text
'        txtControl - text box
'
Sub Console(s$, txtControl As Object)
 
 Dim TextLength&, HalfLimit&, WFragmentLength&
 Dim FullLength&
 Dim c$, wi&

 With txtControl
  TextLength = Len(.Text)
  WFragmentLength = Len(s)
  If WFragmentLength = 0 Then Exit Sub
  
  FullLength = TextLength + WFragmentLength

  If WFragmentLength > mConsole_Text_Limit Or _
     FullLength > mConsole_Text_Limit Then
     HalfLimit = mConsole_Text_Limit / 2
     
     c = "Upper part of console has been cut." _
         & ve & "Cut and remaining texts " & _
         "are alredy saved in file:" & _
         ve & mConsoleAbsPath$
         
     If WFragmentLength > mConsole_Text_Limit Then
        c = c & Right(s, HalfLimit)
     Else
        c = c & Right(.Text & s, HalfLimit)
     End If
     .Text = c
  ElseIf TextLength = 0 Then
     .Text = s
  Else
     c = Right(.Text, 1)
     .SelStart = TextLength - 1
     .SelLength = 1
     .SelText = c & s
  End If
  
  TextLength = Len(.Text)
  If TextLength > 0 Then
  
     'to avoid bad flicker, put cursor on the
     'beginning of string;
     wi = InStrRev_c(Left(.Text, TextLength - 1), vl) + 1
     .SelStart = wi - 1
  
  End If
 End With
End Sub

Property Let TraceApplication(TrueOrNot As Boolean)
  
  If (mTraceApplication And (Not TrueOrNot)) _
     Then
     t "Trace is set to " & TrueOrNot
     mTraceApplication = TrueOrNot
  ElseIf (Not mTraceApplication) And TrueOrNot _
     Then
     mTraceApplication = TrueOrNot
     t "Trace is set to " & TrueOrNot
  End If
  
  If mTraceApplication Then
     If "L" = web_AllowLocal Then
        Me.Visible = True
     End If
  Else
     Me.Visible = False
  End If

End Property

Function InStrRev_c&(s$, key$)
Dim I&, L&, c$, lk%
   InStrRev_c = 0
   L = Len(s)
   If L = 0 Then Exit Function
   lk = Len(key)
   If lk = 0 Then Exit Function
   c = Left(key, 1)
   For I = L To 1 Step -1
       If c = Mid(s, I, 1) Then
          If key = Mid(s, I, lk) Then
             InStrRev_c = I
             Exit Function
          End If
       End If
   Next
End Function


'EXCE   free
'
'DESC   no other controls.
'       no menu.
'YELD   no
'
Public Sub FitObjectInForm( _
           MyForm As Form, _
           MyObj As Object)
Dim WTop&, WLeft&, WWidth&, WHeight&

On Error GoTo he

WTop = 80
WLeft = 110


WWidth = MyForm.Width - 120 - WLeft
If WWidth <= 100 Then WWidth = 100
WLeft = 50

WHeight = MyForm.Height - 480 - WTop
If WHeight < 100 Then WHeight = 100

MyObj.Top = WTop
MyObj.Left = WLeft
MyObj.Height = WHeight
MyObj.Width = WWidth

he: Exit Sub

End Sub



'DESC Puts form right in the center.
'INPU Form object.
'YELD no
'
Public Sub CenterForm(FO As Form)
Dim WLeft&
WLeft = (Screen.Width - FO.Width) / 2
If WLeft < 1 Then WLeft = 1

Dim WTop&
WTop = (Screen.Height - FO.Height) / 2
If WTop < 1 Then WTop = 1

FO.Left = WLeft
FO.Top = WTop
End Sub



Public Function t$(s$)
   t = AddText(Right(CStr(GetTickCount), 4) _
              & " " & Time$ & " " & _
              web_SID & " " & s & ve)
End Function

Private Sub Form_Initialize()

ve = vbCrLf
vr = vbCr
vl = vbLf

mConsoleAbsPath = App.Path & "\" & _
                  mConsoleFileName

'  This flag is disabled by default
'  for speed and security.
'  Set default of this flag here:
mTraceApplication = False

End Sub

Private Sub Form_Load()

If "Y" = IAmLoaded Then
   t "Incorrectly loads twice. This is a bug."
End If

Me.Caption = App.Title & " Console"
CenterForm Me
FitObjectInForm Me, txtHelp
  
    
On Error Resume Next
'If "" <> Dir(mConsoleAbsPath) Then _
'   Kill mConsoleAbsPath

t ve & ve & ve & ve & _
  "**********************************" & ve & _
  "Loading Trace Console." & ve & _
  "Console file = " & ve & _
  mConsoleAbsPath & ve & _
  "**********************************" & ve & _
  ve
   
IAmLoaded = "Y"

End Sub

'EXCEP free
'
'DESCR Adds text to console and
'      appends text to mConsoleAbsPath file "loosely".
'      "Loosely" means no run-time exceptions:
'          if problems, returns string with their description,
'          if no problems, returns an empty string.
'
'
Function AddText$(text_to_append$)
Dim h%  'handler
Dim f$, s$

f = mConsoleAbsPath
    
If Not mTraceApplication Then Exit Function
If text_to_append = "" Then Exit Function

'this avoids reloading Console
'when form desroying process is in progress:
If "L" = web_AllowLocal Then
  If "Y" = IAmLoaded Then
     Console text_to_append, txtHelp
  End If
End If

    
On Error GoTo open_error
h = FreeFile
Open f For Append Shared As #h

On Error GoTo writing_error
Print #h, text_to_append;

Close #h
Exit Function
    
open_error:
   s = CStr(Err.Number) & " " & _
       Err.Description & vbCrLf & _
       "opening file exception ; file=" & f
   Resume ReturnDescription
    
writing_error:
   s = CStr(Err.Number) & " " & _
       Err.Description & vbCrLf & _
       "write exception; file=" & f
   Resume ReturnDescription

ReturnDescription: AddText = s

End Function


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  t "Unloading Trace Console."
End Sub

Private Sub Form_Resize()
FitObjectInForm Me, txtHelp
End Sub



Private Sub Form_Terminate()
t "Terminating Trace Console. " & _
  "Console file = " & _
  mConsoleAbsPath
End Sub

Private Sub Form_Unload(Cancel As Integer)
 IAmLoaded = ""
End Sub



Private Sub txtHelp_KeyPress(KeyAscii As Integer)
  If 27 = KeyAscii Then Unload Me
End Sub


