Attribute VB_Name = "hexArithmetic"
Option Explicit

Const hexDigits$ = "0123456789ABCDEF"
Public hexPowers16$()
Const hexBDigits$ = "01"
Public hexPowers2$()
Public hexSkipChars$


Public Sub hexAnActivation()
Dim ub&, i&
ub = 16
ReDim hexPowers16(ub)
hexPowers16(0) = 1

For i = 1 To ub
    hexPowers16(i) = _
    hexMultiply(hexPowers16(i - 1), "16")
Next

'binary:

ub = 16
ReDim hexPowers2(ub)
hexPowers2(0) = 1

For i = 1 To ub
    hexPowers2(i) = _
    hexMultiply(hexPowers2(i - 1), "2")
Next

hexSkipChars = " ," & vbCr & vbLf & vbTab

End Sub



Public Function hexB2D$(binn$)
Dim l&, r$, dig$, pos&, w$, i&, s$
l = Len(binn)

If 0 = l Then Exit Function

r = "0"
On Error Resume Next
For i = 1 To l
    
    dig = UCase(Mid(binn, l - i + 1, 1))
    pos = InStr(hexBDigits, dig) - 1
    
    'wrong letter:
    If -1 = pos Then Exit Function
    s = hexMultiply(hexBGetPower(i - 1), CStr(pos))
    r = hexSum(s, r)

Next

hexB2D = r

End Function

Public Function hexBGetPower$(n&)
Dim ub&, i&

If n < 0 Then Exit Function
ub = UBound(hexPowers2)

If n > ub Then
   
   ReDim Preserve hexPowers2(n)
   For i = ub To n
       hexPowers2(i) = _
          hexMultiply(hexPowers2(i - 1), "2")
   Next
   
End If

hexBGetPower = hexPowers2(n)

End Function

Public Function hexGetDecimal$(hexn$)
Dim l&, r$, dig$, pos&, w$, i&, s$
l = Len(hexn)

If 0 = l Then Exit Function

r = "0"
On Error Resume Next
For i = 1 To l
    
    dig = UCase(Mid(hexn, l - i + 1, 1))
    pos = InStr(hexDigits, dig) - 1
    
    'wrong letter:
    If -1 = pos Then Exit Function
    s = hexMultiply(hexGetPower(i - 1), CStr(pos))
    r = hexSum(s, r)

Next

hexGetDecimal = r

End Function


Public Function hexGetPower$(n&)
Dim ub&, i&

If n < 0 Then Exit Function
ub = UBound(hexPowers16)

If n > ub Then
   
   ReDim Preserve hexPowers16(n)
   For i = ub To n
       hexPowers16(i) = _
          hexMultiply(hexPowers16(i - 1), "16")
   Next
   
End If

hexGetPower = hexPowers16(n)

End Function

'EXCEP Free
'
'DESC  Adds two numbers a and b
'      represented as strings of
'      "digital digits"
'
'INPUT Both empty a and b or
'      exceptions resut in empty output.
'
'
Public Function hexSum$(a$, b$)
Dim la&, lb&, lm&, i&
Dim s$, d0&, d1&, d2&, d&


la = Len(a)
lb = Len(b)

'empty input triggers empty output:
If 0 = la Or 0 = lb Then Exit Function
lm = la
If lm < lb Then lm = lb

s = ""
d0 = 0

For i = 1 To lm + 1

On Error Resume Next
If i <= la Then
   d1 = CLng(Mid(a, la - i + 1, 1))
   If Err > 0 Then Exit Function 'd1 = 0
Else
   d1 = 0
End If

On Error Resume Next
If i <= lb Then
   d2 = CLng(Mid(b, lb - i + 1, 1))
Else
   d2 = 0
End If
If Err > 0 Then Exit Function 'd2 = 0


d = d1 + d2 + d0
If i = lm + 1 And d = 0 Then Exit For

s = CStr(d Mod 10) & s
d0 = Int(d / 10)

Next


ExitFunction: hexSum = s


End Function

'EXCEP  Free
'INPUT  a - string representing decimal number
'       b - decimal digit
'OUTPUT Empty strings or exceptions
'       cause empty result.
'
'
Public Function hexMultiplyByDigit$(a$, d$)
Dim la&, lm&, i&
Dim s$, d0&, d1&, dd


la = Len(a)
lm = la

'empty input triggers empty output:
If "" = d Or "" = a Then Exit Function
If d = "0" Then
   s = "0"
   GoTo ExitFunction
End If


s = ""
d0 = 0

For i = 1 To lm + 1

  On Error Resume Next
  If i <= la Then
     d1 = CLng(Mid(a, la - i + 1, 1))
     If Err > 0 Then Exit Function 'd1 = 0
  Else
     d1 = 0
  End If


  dd = d1 * d + d0
  If i = lm + 1 And dd = 0 Then Exit For

  s = CStr(dd Mod 10) & s
  d0 = Int(dd / 10)

Next


ExitFunction: hexMultiplyByDigit = s


End Function


'EXCEP  Free
'INPUT  a, b- strings representing decimal numbers
'OUTPUT Empty strings cause empty result.
'
Public Function hexMultiply$(a$, b$)
Dim lb&, i&
Dim s$, ss$, d2$

s = ""
If "" = a Or "" = b Then GoTo ExitFunction
lb = Len(b)

s = "0"
For i = 1 To lb

  d2 = Mid(b, lb - i + 1, 1)
  ss = hexMultiplyByDigit(a, d2) & _
       String(i - 1, "0")
  s = hexSum(s, ss)

Next

ExitFunction: hexMultiply = s

End Function



