<?php // require("../replacers.inc"); 
 ?>
<?php 
   //DESCR
   //  simply extracts string R=Text[[""]Text] from
   //  Source which is = ..."Text[[""]Text]"......
   //
   //
   //INPUT:
   //   SourceS - must have "
   //             at StartPos which will be skipped and which marks
   //             the beginning of the searched string;
   //   StartSearchPos - first Mark position
   //             remmed: position where to start first q-mark seach
   //   RecognizeDoubleQuoters - if true, then pair "" converted ...
   //       if ReduceDoubleQuoters = true, ... to "
   //                              = false, ... to ""
   //   StripQMarks - if true, then  R   is returned
   //                 otherwise     "R"  is returned.
   //   Mark     - this is a character which can be used instead of ""
   //              for example single quotation mark 
   //   ReduceDoubleQuoters
   //OUTPUT: returns R or "R"
   //        EndPos - character next after last "
   //
   //NOTE
   //


function cutquotedstring($startsearchpos,$sources,$mark,$recognizedoublequouters,$reducedoublequoters,$stripqmarks,&$endpos){
   
   $result="";
   $cutquotedstring="";
   $resultl=strlen($sources);
   $startpos=$startsearchpos;
   //to search for first Mark:
   //StartPos = InStr(StartSearchPos, SourceS, Mark)
   $endpos=$startsearchpos;
   if($startpos == 0 | $startpos == $resultl){return $cutquotedstring;
   }
   //first character (usually ") is skipped:
   $currentpos=$startpos + 1;
   if($currentpos > strlen($sources)){
      $endpos=$resultl + 1;
      return $cutquotedstring;
   }
   do { 
      //locate position of the next ":
      $wi=instr_c_($currentpos,$sources,$mark);
      if($wi == 0){
         //return all plus "complete" string with ":
         $result=$result . substr($sources,$currentpos-1);
         $endpos=$resultl + 1;
         break; //break of string found
      }
      $result=$result . substr($sources,$currentpos-1,$wi - $currentpos);
      if(substr($sources,$wi + 1-1,1) == $mark & $recognizedoublequouters){
         $currentpos=$wi + 2;
         $result=$result . $mark;
         if(!$reducedoublequoters){$result=$result . $mark;
         }
      }else { 
         $endpos=$wi + 1;//next pos
         break; //end of string found
      }
   } while(TRUE);
   //If tz_conv_str = "P" Then _
   //   result = Replace(Replace(Replace(result, "\", "\\"), """""", "\"""), "$", "\$")
   if($stripqmarks){
      $cutquotedstring=$result;
   }else { 
      $cutquotedstring=$mark . $result . $mark;
   }
   return $cutquotedstring;
}
    ?>