Attribute VB_Name = "ASCIIHandler"
Option Explicit

Public HArr$(16)
'Public UnpritableCharEscape$   'set at start up;
Public HowManyReplacements&
'Public CharRange$


'INPUT: if DisplayLineEnd = "R" - adds ve after each carriage return if not in
'                                 combination with lf; if in combination,
'                                 each crlf causes ve;
'                         = "L" - adds ve after each line feed;
'                         = "RL"-  ... after each CRLF;
'                         = "A" - any appropriate;  any lf and any cr witout lf;
'                         = "V" - ("visualize") A and not escape which > 126;
'                         = "Z" - escapes only zero char;
'
'
'Ultimately adds chr(0) if text has it.
'A - seems the best
'Range goes from golobal ...
'^r ^n ^t ^z  stand for cr,lf,tab,zero
'
Public Function asc_T(Sour_ce$, UnpritableCharEscape$, CharRange$, DisplayLineEnd$, CountedPosition&)
Dim MessageLength&, WAsc%, ws$, wi&
Dim MessageToDisplay$
Dim WHex1%, WHex2%
Dim ZeroCounted&, ResultCountedPosition&


MessageLength = Len(Sour_ce)

'ppppppp "protectors"
If CountedPosition < 0 Then
   MsgBox "Unexpected: escaping with cursor < 0 "
   CountedPosition = 0
End If
If CountedPosition > MessageLength Then
   MsgBox "Unexpected: escaping with cursor > len "
   CountedPosition = MessageLength
End If
'ppppppppp ef "protectors"

'ultimately add chr(0) if text has it:
If InStr(Sour_ce, Chr(0)) > 0 Then
   If InStr(CharRange, Chr(0)) = 0 Then CharRange = Chr(0) & CharRange
End If

ResultCountedPosition = CountedPosition
If CharRange = "" Then
   MessageToDisplay = Sour_ce
   GoTo ExitFunction
End If

'if there are chars to escape, but no escape char, then
'make it default as "^":
If UnpritableCharEscape = "" Then UnpritableCharEscape = "^"
   
MessageToDisplay = ""
If Sour_ce = "" Then GoTo ExitFunction


HowManyReplacements = 0
For wi = 1 To MessageLength
    DoEvents
    ws = Mid(Sour_ce, wi, 1)
    WAsc = Asc(ws)
    
    '---------------------------------------------------------------
    If ws = UnpritableCharEscape Then
       ws = ws & ws        'escape escape char itself:
       HowManyReplacements = HowManyReplacements + 1
    '---------------------------------------------------------------
    'ElseIf (WAsc < 32 Or WAsc > 126) And WS <> vt Then
    ElseIf InStr(CharRange, ws) > 0 Then

       'If DisplayLineEnd = "V" And WAsc > 32 Then GoTo AddCharacter
       'If DisplayLineEnd = "Z" Then GoTo AddCharacter
    '---------------------------------------------------------------
    'this escapes unprintable and high ascii except tab:
    '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
       HowManyReplacements = HowManyReplacements + 1
       WHex1 = Int(WAsc / 16)
       WHex2 = WAsc Mod 16
       ws = UnpritableCharEscape & _
            HArr(WHex1) & HArr(WHex2)
       If WAsc = 10 Then ws = UnpritableCharEscape & "n"
       If WAsc = 9 Then ws = UnpritableCharEscape & "t"
       If WAsc = 13 Then ws = UnpritableCharEscape & "r"
       If WAsc = 0 Then ws = UnpritableCharEscape & "z"
       '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
            
       '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
       '        visualize line end;
       '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
       Select Case DisplayLineEnd
          '............ most practical case .....................
          'supposed that 10 and 13 are escaped both concurrently:
          Case "A", "V"
               If WAsc = 10 Then
                  ws = ws & vbCrLf
               ElseIf WAsc = 13 Then
                  If Mid(Sour_ce, wi + 1, 1) <> vbLf Then
                     ws = ws & vbCrLf
                  End If
               End If
          '..........................................
          Case "R":
               If WAsc = 13 Then
                  If Mid(Sour_ce, wi, 2) <> vbCrLf Then
                     'because, this will print ve
                     'at the next step;
                     ws = ws & vbCrLf
                  End If
               ElseIf wi > 1 Then
                  If Mid(Sour_ce, wi - 1, 2) = vbCrLf Then
                     ws = ws & vbCrLf
                  End If
               End If
          Case "L":
               If WAsc = 10 Then ws = ws & vbCrLf
          Case "RL":
               If wi > 1 Then
                  If Mid(Sour_ce, wi - 1, 2) = vbCrLf Then
                     ws = ws & vbCrLf
                  End If
               End If
       End Select
       '---------------------------------------------------------------
    End If
AddCharacter:      MessageToDisplay = MessageToDisplay & ws
                   If CountedPosition = wi Then ResultCountedPosition = Len(MessageToDisplay)
Next

ExitFunction: asc_T = MessageToDisplay
              CountedPosition = ResultCountedPosition
End Function

'needs to be run at StartUp
'
Public Sub asc_MakeHexArray()
Dim wi&
For wi = 0 To 15
   If wi < 10 Then HArr(wi) = Chr(48 + wi)
   If wi > 9 Then HArr(wi) = Chr(97 + wi - 10)
Next
End Sub




'DESCRIPTION:
' unescapes following if key E = "\":
' \\ \r \n \t \05 \af \0f  \NDDD
' if \ does not have matching key, then it is preserved
' \N065 --> A; \41 --> A;
'
'INPUT: S - source string; E - escape char;
'       if E = "", then string is returned unchanged;
'
'OUTPUT: returns result sting;
'
'
'
Public Function asc_UT$(S$, E$, CharRange$, CountedPosition&)
Dim I&, L&, Sta_rt&, ws$, wi&, I1&, WSS$, WII&
Dim WRes$, WTail$
Dim ResultCountedPosition&
Dim ResultCountedPositionSet As Boolean

On Error GoTo he

L = Len(S)
If L = 0 Then
   WRes = ""
   ResultCountedPosition = 0
   ResultCountedPositionSet = True 'deb
   GoTo ExitFunction
End If

If CharRange = "" Or E = "" Then
   WRes = S
   ResultCountedPosition = CountedPosition
   ResultCountedPositionSet = True 'deb
   GoTo ExitFunction
End If

'----------------------------------------
' normalize CountedPosition
'- - - - - - - - - - - - - - - - - - - -
If CountedPosition > Len(S) Then
   CountedPosition = Len(S)
   MsgBox "Pos > len"
End If

If CountedPosition < 0 Then
   CountedPosition = 0
   MsgBox "pos < 0"
End If

If CountedPosition = 0 Then
   ResultCountedPosition = 0
   ResultCountedPositionSet = True
Else
   ResultCountedPositionSet = False
End If


WRes = ""
Sta_rt = 1
  
I = InStr(Sta_rt, S, E)
Do While I <> 0
   DoEvents
   
   '----------------------------------------------------------------------
   'add piece before escape char:
   'If I > Sta_rt Then
      If CountedPosition <= I And Not ResultCountedPositionSet Then
         '"overlapped", but not set yet;
         If CountedPosition >= Sta_rt Then
            WTail = Mid(S, Sta_rt, CountedPosition - Sta_rt + 1)
            If InStr(CharRange, vbLf) > 0 Then
               WTail = Replace(WTail, vbLf, "")
            End If
            If InStr(CharRange, vbCr) > 0 Then
               WTail = Replace(WTail, vbCr, "")
            End If
         Else
            WTail = ""
         End If
         ResultCountedPosition = Len(WRes) + Len(WTail)
         ResultCountedPositionSet = True
      End If
      
      ws = Mid(S, Sta_rt, I - Sta_rt)
      If InStr(CharRange, vbLf) > 0 Then
         'cut extra lf which supposedly encoded any way
         'and will be duplicated otherwise;
         ws = Replace(ws, vbLf, "")
      End If
      If InStr(CharRange, vbCr) > 0 Then
         'cut extra cr which supposedly encoded any way
         'and will be duplicated otherwise;
         ws = Replace(ws, vbCr, "")
      End If
      
      WRes = WRes & ws
   'end if
   '----------------------------------------------------------------------
   
   If I = L Then
      'last escape char wihout key added itself (optimistic):
      WRes = WRes & E
      GoTo ExitFunction
   Else
      I1 = I + 1
      ws = Mid(S, I1, 1)
      wi = Asc(ws)
      'if key starts with digit => do this as ascii:
      If (wi < 58 And wi > 47) Or _
         (wi <= 102 And wi >= 97) Then
         '-----------------------------------------------------------
         'hex (\0a or \55 or \4f ) is found:
         
          On Error Resume Next
          ws = UCase(Mid(S, I1, 2))
          WRes = WRes & _
             Chr(CInt("&H" & ws))
          If Err.Number > 0 Then e_raise _
             "invalid hexadecimal value: " & E & ws
          On Error GoTo he
         
         '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
         'may slow:
         'If I + 2 > L Then exitfunction
         'WSS = Mid(S, I + 2, 1)
         'WII = Asc(WSS)
         'If WII < 58 And WII > 47 Then
         '      WII = WII - 48   'digit
         'ElseIf WII <= 102 And WII >= 97 Then
         '      WII = 10 + WII - 97
         'Else 'exception; terminate:
         '      exitfunction
         'End If
         
         'If WI < 58 And WI > 47 Then
         '      WI = WI - 48   'digit
         'Else
         '      WI = 10 + WI - 97
         'End If
         'WS = Chr(WI * 16 + WII)
         'WRes = WRes & WS
         '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
         
         Sta_rt = I + 3
         GoTo ContinueLoop
      End If
      Select Case ws
          Case E:   WRes = WRes & E
                    Sta_rt = I + 2
          Case "r": WRes = WRes & vbCr
                    Sta_rt = I + 2
          Case "n": WRes = WRes & vbLf
                    Sta_rt = I + 2
          Case "t": WRes = WRes & Chr(9)
                    Sta_rt = I + 2
          Case "z": WRes = WRes & Chr(0)
                    Sta_rt = I + 2
          'redundant:
          'Case "x", "X" ' this converts "h41" to chr(65) = "A" :
          '              WRes = WRes & Chr(CInt("&H" & UCase(Mid(S, I + 2, 2))))
          '              Sta_rt = I + 4
          Case "N"  '\N045 ...         'decimal escapes:
                    WRes = WRes & Chr(CInt(Mid(S, I1, 3)))
                    Sta_rt = I + 4
          Case Else: WRes = WRes & E & Mid(S, I + 1, 1)
                    Sta_rt = I + 2
        End Select
     End If
ContinueLoop:  I = InStr(Sta_rt, S, E)
Loop

If Not ResultCountedPositionSet Then
         '"overlapped", but not set yet;
         If CountedPosition >= Sta_rt Then
            WTail = Mid(S, Sta_rt, CountedPosition - Sta_rt + 1)
            If InStr(CharRange, vbLf) > 0 Then
               WTail = Replace(WTail, vbLf, "")
            End If
            If InStr(CharRange, vbCr) > 0 Then
               WTail = Replace(WTail, vbCr, "")
            End If
        Else
            WTail = ""
         End If
         ResultCountedPosition = Len(WRes) + Len(WTail)
         ResultCountedPositionSet = True
End If


If Sta_rt <= L Then
      
   ws = Mid(S, Sta_rt)
   If InStr(CharRange, vbLf) > 0 Then
         'cut extra lf which supposedly encoded any way
         'and will be duplicated otherwise;
         ws = Replace(ws, vbLf, "")
   End If
   If InStr(CharRange, vbCr) > 0 Then
         'cut extra cr which supposedly encoded any way
         'and will be duplicated otherwise;
         ws = Replace(ws, vbCr, "")
   End If
   WRes = WRes & ws
End If

                   
ExitFunction:
               asc_UT = WRes
               If Not ResultCountedPositionSet Then
                  MsgBox "Unexpected value of virtual cursor:" & ResultCountedPosition
               End If
               CountedPosition = ResultCountedPosition
               
Exit Function
he:  xMe = Err.Description
     xNo = Err.Number
     Resume xNext
xNext:
     On Error GoTo 0
     eUp "when unescaping in text"
  
End Function







