Attribute VB_Name = "FileHandler"
 ' this module is a replacement for web `common.inc` file
 Option Explicit
 
 Public Type BufferedText
   
   Buffable As String
   DeleteFileAtBeginning As String
   DeleteBufferAtEnd As String
   
   FileHandler As Integer
   
   FileName As String
   FileBufferName As String
   
   FileText As String
   BufferSize As Long
   FileSize As Long                 'can be 0
   TextSize As Long
   UpperBoundary As Long            'never less than 1
   
   WorkingWithBuffer As String
   FileIsOpen As String

 End Type
 
 
 
 
 
 
 
 
 
 
 
 
 'Public commonD As CommonDialog
 Public txtobj As Object

 Public sscom As sscomp
 Public outf$
 
 'to communicate with dll:
 Public GivePosition&
 Public GiveSourcePos&
 Public GiveResultPos&
 Public GiveSchemaPos&
    
  
 Public SourceFileBuffered As BufferedText
 Public ResultFileBuffered As BufferedText
 Public SchemaFileBuffered As BufferedText
  
    
 Public TopFolderToProcess$
 Public input_project_file_name$
 Public input_schema_file_name$
 Public input_source_file_name$
 Public result_file_name$
 
 Public ProjectNameRaw$
 Public SourceNameRaw$
 Public SchemaNameRaw$
 Public ResultNameRaw$
  
 Public SchemaPath$
 Public SourcePath$
 Public ResultPath$
 Public ProjectPath$
 
 Public Const ResultTree$ = "ResultTree"

 'KK.arc Public status_file_name$
 Public ConsoleNameRaw$
 

 Public prepare_task_allowed As Boolean
 
 Public Const output_time_slice# = 0.1    ' milisec
  
 
Public Sub Buff_Close(BufferedType As BufferedText)
    With BufferedType
    Close .FileHandler
    If .Buffable = "T" And .WorkingWithBuffer = "T" Then
       If .DeleteBufferAtEnd = "T" Then
          Kill .FileBufferName
       End If
    End If
    End With
End Sub

Public Sub Buff_MoveWorkToBuffer(BufferedType As BufferedText)
 Dim NameToOpen$
  
 With BufferedType
 
 .WorkingWithBuffer = "T"
 .FileBufferName = .FileName & ".buff"
 
 Close .FileName
 
 FileCopy .FileName, .FileBufferName
 NameToOpen = .FileBufferName
 
 .FileHandler = FreeFile
 
 Open NameToOpen For Binary Access Read Write _
 Lock Read Write As .FileHandler
 End With

End Sub

'
' made for result file mainly
'
Public Sub Buff_CreateResultType(BufferedType As BufferedText)
 
 With BufferedType
 
 .Buffable = "F"
 .DeleteFileAtBeginning = "F"
 
 .FileHandler = FreeFile
 .FileText = String(.BufferSize, " ")
 .UpperBoundary = 1
 
 
 Open .FileName For Binary Access Read Write _
 Lock Read Write As .FileHandler
 .FileSize = 0
 .FileText = 0
 .FileIsOpen = "T"
  
 End With
 
End Sub

'
'made for source files;
'
Public Sub Buff_FirstRead(BufferedType As BufferedText, TypeSource As String)
   
 With BufferedType
   
 If TypeSource = "T" Then
      .Buffable = "T"
      .DeleteBufferAtEnd = "T"
      .WorkingWithBuffer = "F"
 Else
      .Buffable = "F"
      .DeleteBufferAtEnd = "F"
 End If
   
 .FileHandler = FreeFile
 .UpperBoundary = 1
 
 
 
 Open .FileName For Binary Access Read Write _
 Lock Read Write As .FileHandler
 .FileIsOpen = "T"
 
 .FileSize = LOF(.FileHandler)
 

 .TextSize = .FileSize
 If .TextSize < 1 Then
    .TextSize = 0
    .FileText = ""
    Exit Sub
 End If
 If .TextSize > .BufferSize Then .TextSize = .BufferSize
 .FileText = String(.TextSize, " ")
 
 
 
 Get .FileHandler, .UpperBoundary, .FileText
 
 End With
 
End Sub







Public Sub Buff_ReadAround(BufferedType As BufferedText, ReadAt&)
 Dim ReadPosition&

 With BufferedType
      ReadPosition = ReadAt - .BufferSize / 2
      If ReadPosition < 1 Then ReadPosition = 1
      Buff_ReadAt BufferedType, ReadPosition
 End With


End Sub

Public Sub Buff_ReadAt(BufferedType As BufferedText, ReadAt&)
  With BufferedType
 '.FirstCall = "F"
 
 If ReadAt > .FileSize Then e_app "file read position > FileSize for buffered text"
 If ReadAt < 1 Then e_app "file read position < 1 for buffered text"
 
 If .FileSize < .BufferSize Then
    .UpperBoundary = 1
 ElseIf .FileSize - ReadAt + 1 < .BufferSize Then
    .UpperBoundary = .FileSize - .BufferSize + 1
 Else
    .UpperBoundary = ReadAt
 End If
 
 
 .TextSize = .FileSize - .UpperBoundary
 If .TextSize < 1 Then
    .TextSize = 0
    .FileText = ""
    Exit Sub
 End If
 If .TextSize > .BufferSize Then .TextSize = .BufferSize
 .FileText = String(.TextSize, " ")
 
 Get .FileHandler, .UpperBoundary, .FileText
 '.LowBoundary = .UpperBoundary + .BufferSize - 1
 End With
End Sub


Public Sub Buff_Save(BufferedType As BufferedText)
  
 With BufferedType
 If .Buffable = "T" Then
   If .WorkingWithBuffer <> "T" Then
     Buff_MoveWorkToBuffer BufferedType
   End If
 End If
 
 If .FileIsOpen = "T" Then
    Put #.FileHandler, .UpperBoundary, .FileText
 Else
    Buff_CreateResultType BufferedType
    Put #.FileHandler, .UpperBoundary, .FileText
    'refresh file size:
    .FileSize = LOF(.FileHandler)
 End If
 '.CurrentPosition = .UpperBoundary + .BufferSize - 1
 End With

End Sub

Sub con_L(s$)
  OutsImmediate s & ve
End Sub

Sub con_L_M(s$)
 con_L s
 MsgBox s
End Sub

Sub con_NL_M(s$)
 con_NL s
 MsgBox s
End Sub


Sub con_(s$)
  OutsImmediate s
End Sub


Sub con_NL(s$)
OutsImmediate ve & s & ve
End Sub


' OUTPUT STREAM
Sub Outs(s$)
    If Len(outf) > output_text_slice Or _
       output_timeline < Timer Then _
       OutsImmediate (s) Else outf = outf & s
End Sub



Sub OutsImmediate(s$)
    
Dim WS$

On Error GoTo he

outf = outf & s
If outf = "" Then Exit Sub

OpenAndAppendToFile ConsoleNameRaw, outf
If Not no_gui Then
   console outf, ssmain.txtConsole
   'If frmEdit.current_text = "console" Then console outf, frmEdit.txtEdit
End If
'OpenAndAppendToFile ConsoleNameRaw, outf
'upto(open_and_append_to_file(ConsoleNameRaw, outf), vl, message) <> "done" Then
    
outf = ""
output_timeline = Timer + output_time_slice
Exit Sub


he: WS = "exception when saving console" & ConsoleNameRaw & ve & _
    Err.Number & Err.Description
    'write this message directly into main form console:
    console WS, ssmain.txtConsole
    e_app WS

End Sub







