VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsApplicationCaller"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Public file_name$
Public Exceptions$

  ' Call Parameters
Public Scenario As Variant
Public Session_call_number As Variant
Public WebOrLocal As Variant
Public SessionID As Variant
Public Trace_application As Variant
Public Ignore_input_properties As Variant



Private Sub Class_Initialize()
  Dim ws$

  file_name = _
       App.Path & "\" & "ApplicationCaller_preferences.dat"
  ws = read_me()
  If "" <> ws Then MsgBox ws
  If "Missed" = Left(Exceptions, 6) Then
     'no exception handling for defaults
     'assuming that programmer is careful:
        Scenario = "P"
   Session_call_number = "0"
   SessionID = "-1"
   WebOrLocal = "L"
   Trace_application = "True"
   Ignore_input_properties = "True"



  End If

  Validate
  
End Sub

Public Sub Validate()


End Sub

'=============================
'  save preferences
'-----------------------------
Public Function write_me()
  Dim L&, s$
  Dim h% '=file handler

  'clear exception state:
  Exceptions = ""
  On Error GoTo he
  h = FreeFile
  Open file_name For Binary Shared As #h

 s = CStr(Scenario): L = Len(s): Put h, , L: Put h, , s
 s = CStr(Session_call_number): L = Len(s): Put h, , L: Put h, , s
 s = CStr(WebOrLocal): L = Len(s): Put h, , L: Put h, , s
 s = CStr(SessionID): L = Len(s): Put h, , L: Put h, , s
 s = CStr(Trace_application): L = Len(s): Put h, , L: Put h, , s
 s = CStr(Ignore_input_properties): L = Len(s): Put h, , L: Put h, , s

  
  Close h
  'clear exception state:
  Exit Function

he:  s = "Exception " & _
         CStr(Err.Number) & " " & _
         Err.Description & vbCrLf & _
         "when writing to file:" & vbCrLf & _
         file_name
     Resume xHe
xHe: write_me = s
     Exceptions = s

End Function
  
'=============================
'  read preferences
'-----------------------------
Public Function read_me$()
  Dim L&, s$
  Dim h% '=file handler
  'clear exception state:
  Exceptions = ""
  On Error GoTo he

  If Dir(file_name) = "" Then
     Exceptions = "Missed preference file: " & _
                  file_name
     Exit Function
  End If

  h = FreeFile
  Open file_name For Binary Shared As #h

  Get h, , L: s = Space(L): Get h, , s: Scenario = s
  Get h, , L: s = Space(L): Get h, , s: Session_call_number = s
  Get h, , L: s = Space(L): Get h, , s: WebOrLocal = s
  Get h, , L: s = Space(L): Get h, , s: SessionID = s
  Get h, , L: s = Space(L): Get h, , s: Trace_application = s
  Get h, , L: s = Space(L): Get h, , s: Ignore_input_properties = s

  
  Close h
 
  Exit Function
he:  s = "Exception " & _
         CStr(Err.Number) & " " & _
         Err.Description & vbCrLf & _
         "when reading file:" & vbCrLf & _
         file_name & vbCrLf & _
         "approximately at value: " & _
         Left(s, 100)
     Resume xHe
xHe: read_me = s
     Exceptions = s

End Function
