VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'*********************************************************************************
'       EVENT
'=================================================================
'       EVENT-STATEMENT
'=================================================================
Private es_nest&(1000, 10)                    'nest-pattern in form of indicies.
Private es_nest_size&(1000)
Public es_EvStatementsNumber&                'how many events are really registered
     

Private es_token$(1000)
Private es_type$(1000)
Private es_NO_ESCAPES(1000) As Boolean            'does not need to be substituted

Private es_post_beginning&(1000)                  '0 - means nothing
Private es_post_end&(1000)

Private es_global_type$(1000)
Private es_activated(1000) As Boolean
'============================================================================


'--------------------------------------
'Streams (when parsing?)
Private OpenStreams&()
Public StreamsOpen&
'--------------------------------------




'===========================================================================
' Run-Time Nest
'---------------------------------------------------------------------------
'do1 prevent array overflow: rtNestDimension
Private g_nest&()               'Run-Time Nest (Current nest of dialog) =
                                'array of current states
Public rtNestDimension&
Public dlgPs&                   'Level in Run-Time Nest.
Private g_NestVariable$()       '"Commonly used" variable @
                                'in schema corresponded to
                                'current level in nest.
                                'MUST have the same dimension as g_nest in CDialog
'---------------------------------------------------------------------------
' Run-Time Nest
'===========================================================================

'Run Time parameter:
Public oCondition$


Private GlobQueueDepository() As CommonQueue

Private g_que_Comm(5000) As CommonQueue
Private g_que_GarbageCleaner As CommonQueue
Public Ubound_g_que&
Private Const Ubound_g_que_M& = 4999



Public DlgNm&                  'current dialog number

Private moAc As Acto

Private moXc As CException
Private moTz As CTokenizer
Private moPc As CProcedure
Private moPr As CPrint
Private moVr As CVariables
Private moFt As CFolderTree

'License works:
'Private moCr As CCheckRegistration


'*********************************************************************************
'   user environment
'=================================================================================
Public deb As Boolean
Public ddeb As Boolean         'Ddouble debug which is in effect when deb is true.
Public do_step As Boolean

'Public dialog_suspended_at&
'Public dialog_suspended As Boolean 'was lost; wis?
'Public dialog_resumed_at&
'Public TerminationIsCompleted As Boolean


'---------------------------------------------------------------------------------
'   text interrupting parameters:
Public flag_TEXT_STOPPED As Boolean
'---------------------------------------------------------------------------------

'Output result and print:
Public Indent_Replacer$    '=actual indent which is ready to
                           ' be output;
                           ' indent_body = <INDENT CONSTANT>
                           '             = what be repeated n-times;
                           'Indent_Replacer = ve & <n*INDENT CONSTANT>



'Statistics:
Public MaximumNest&
Public MaximumQueue&

Public suspended As Boolean


'Switches:
Public env_p_id_is_case_sensetive As Boolean 'Dialog
Public env_word_case_sensetive As Boolean

'Variables?:
Public glEsLIST_QUESTION_Ix& 'Index in array: var_Values(). Flag. 0 means no match ever happened.
Public mEsLIST_QUESTION_Start&
Public mEsLIST_QUESTION_Len&

'For Xceptions:
Private espot$
Private xMe$, xNo&

Public Function GlobQueueDepository_Ubound&()
GlobQueueDepository_Ubound = UBound(GlobQueueDepository)
End Function


Public Function GlobQueueDepository_Ubound_Redim1()

Dim I&
I = UBound(GlobQueueDepository) + 1
ReDim Preserve GlobQueueDepository(I)
GlobQueueDepository_Ubound_Redim1 = I

End Function


Public Sub SetMoActo(ac As Acto)
Set moAc = ac
End Sub

'*********************************************************************************
Public Function GloblaQueue_for_display$()
Dim ws$, wi&
If Ubound_g_que > 0 Then Exit Function

For wi = 1 To Ubound_g_que
    If ddeb Then ws = ws & wi & "/ "
    ws = ws & Action_for_display(g_que_Comm(wi), moTz) & ve
    DoEvents
Next

GloblaQueue_for_display = ws

End Function

Property Get NestLevelVar(Ix As Long) As String
NestLevelVar = g_NestVariable(Ix)
End Property

Property Let NestLevelVar(Ix As Long, val As String)
g_NestVariable(Ix) = val
End Property


Public Property Get Open_Streams(Ix As Long) As Long
Open_Streams = OpenStreams(Ix)
End Property

Public Property Let Open_Streams(Ix As Long, val As Long)
OpenStreams(Ix) = val
End Property

Property Let RunTimeNest(Ix As Long, val As Long)

g_nest(Ix) = val

End Property

Property Get RunTimeNest(Ix As Long) As Long

RunTimeNest = g_nest(Ix)

End Property

Public Sub SetDdebug(ddb As Boolean)

ddeb = ddb
If ddeb Then SetDebug True

End Sub

Public Sub SetDebug(db As Boolean)
deb = db
moTz.SetDebug db
moPc.SetDebug db
End Sub


Public Sub SetMoVariables(vr As CVariables)
Set moVr = vr
End Sub

Private Sub Action_to_panel(QE As CommonQueue)

moPr.prn_SI Action_for_display(QE, moTz), False

End Sub

Public Sub SetMoProcedure(pc As CProcedure)
Set moPc = pc
End Sub

Public Sub SetMoPrint(pr As CPrint)
Set moPr = pr
End Sub



Public Sub SetMoException(xc As CException)
Set moXc = xc
End Sub



Public Sub SetMoTokenizer(tz As CTokenizer)
Set moTz = tz
End Sub

Public Sub SetMoFolderTree(ft As CFolderTree)
Set moFt = ft
End Sub

Public Sub GlobQueueDepository_Get(Ix As Long, _
                    Interaction As String, _
                    First As String, _
                    Second As String, _
                    Third As String, _
                    Fourth As String, _
                    Numberr As Long, _
                    StateShift As Long, _
                    FirstStatus As String, _
                    FourthStatus As String)
                   
With GlobQueueDepository(Ix)
     Interaction = .Interaction
     First = .First
     Second = .Second
     Third = .Third
     Fourth = .Fourth
     Numberr = .Numberr
     FirstStatus = .FirstStatus
     FourthStatus = .FourthStatus
End With

End Sub

Public Sub GlobQueueDepository_Let(Ix As Long, _
                    Interaction As String, _
                    First As String, _
                    Second As String, _
                    Third As String, _
                    Fourth As String, _
                    Numberr As Long, _
                    StateShift As Long, _
                    FirstStatus As String, _
                    FourthStatus As String)
                   
With GlobQueueDepository(Ix)
     .Interaction = Interaction
     .First = First
     .Second = Second
     .Third = Third
     .Fourth = Fourth
     .Numberr = Numberr
     .FirstStatus = FirstStatus
     .FourthStatus = FourthStatus
End With

End Sub



'RETURN true if stops
'       false if no stops
'
'
Public Function watchTerminateText() As Boolean


'===================================
'ultimately continue termination
'process if requested
'-----------------------------------
If flag_TEXT_STOPPED Then
   watchTerminateText = True
   Exit Function
Else
   watchTerminateText = False
End If
'===================================


If suspended Then
   DoEvents
   Do Until do_step Or Not suspended Or _
            flag_TEXT_STOPPED
      DoEvents
   Loop
   do_step = False
Else
   DoEvents
End If


If flag_TEXT_STOPPED Then watchTerminateText = True


End Function


'EXCE free ("relies on Uboud_g_que is not over.")
'DESC Really disposes garbage from all
'     global queue.
'     Sets global queue length to 0.
Public Sub CleanQueueAndCondition()
Dim I&
For I = 0 To Ubound_g_que
   g_que_Comm(I) = g_que_GarbageCleaner
Next
Ubound_g_que = 0
oCondition = ""     'clears all stuff related to conditions;
End Sub

Public Property Let esNest(Ix1 As Long, Ix2 As Long, val As Long)
 es_nest(Ix1, Ix2) = val
End Property


Public Property Let esType(Ix1 As Long, val As String)
 es_type(Ix1) = val
End Property

Public Property Let esGlobal_type(Ix1 As Long, val As String)
 es_global_type(Ix1) = val
End Property

Public Property Get esGlobal_type(Ix1 As Long) As String
 esGlobal_type = es_global_type(Ix1)
End Property

Public Property Let esPost_beginning(Ix1 As Long, val As Long)
 es_post_beginning(Ix1) = val
End Property

Public Property Get esPost_beginning(Ix1 As Long) As Long
 esPost_beginning = es_post_beginning(Ix1)
End Property


Public Property Let esPost_end(Ix1 As Long, val As Long)
 es_post_end(Ix1) = val
End Property

Public Property Get esPost_end(Ix1 As Long) As Long
 esPost_end = es_post_end(Ix1)
End Property

Public Property Let esNO_ESCAPES(Ix1 As Long, val As Boolean)
 es_NO_ESCAPES(Ix1) = val
End Property

Public Property Get esNO_ESCAPES(Ix1 As Long) As Boolean
 esNO_ESCAPES = es_NO_ESCAPES(Ix1)
End Property

Public Property Let esActivated(Ix1 As Long, val As Boolean)
 es_activated(Ix1) = val
End Property

Public Property Get esActivated(Ix1 As Long) As Boolean
 esActivated = es_activated(Ix1)
End Property

Public Property Get esType(Ix1 As Long) As String
 esType = es_type(Ix1)
End Property


Public Property Get esNest(Ix1 As Long, Ix2 As Long) As Long
 esNest = es_nest(Ix1, Ix2)
End Property


Public Property Let esNest_size(Ix1 As Long, val As Long)
 es_nest_size(Ix1) = val
End Property

Public Property Let esToken(Ix1 As Long, val As String)
 es_token(Ix1) = val
End Property


Public Property Get esToken(Ix1 As Long) As String
 esToken = es_token(Ix1)
End Property

Public Property Get esNest_size(Ix1 As Long) As Long
 esNest_size = es_nest_size&(Ix1)
End Property


'EXCE free
'
Public Sub resetQueuStreamsConditionIndent()
  resetStreamsConditionIndent
  CleanQueueAndCondition
End Sub



'EXCE free
'
Private Sub resetStreamsConditionIndent()
oCondition = ""       'clears all stuff related to conditions;
ReDim OpenStreams&(0)
StreamsOpen = 0
Indent_Replacer = ""
End Sub



'This sub does not touch variables at all.
'
'
Public Sub resetNestQueStreamsConditionIndent()
   
dlgPs = 1
g_nest(1) = si__Root
If MaximumNest < dlgPs Then _
   MaximumNest = dlgPs
   
resetQueuStreamsConditionIndent
   
End Sub

Public Sub MoveToQueueDepository(AInteraction$, WArray, Wstatus, TokensNumber&, ShiftForState&)
Dim W_QE_Index&
'=====================================================================================================================================
'   ADVANCE DEPOSITORY
'-------------------------------------------------------------------------------------------------------------------------------------
W_QE_Index = UBound(GlobQueueDepository) + 1

'make a reference from this event-statement to the START of queue:
If es_post_beginning(es_EvStatementsNumber) = 0 Then
   es_post_beginning(es_EvStatementsNumber) = W_QE_Index
End If
'make a reference from this event-statement to the END of queue:
es_post_end(es_EvStatementsNumber) = W_QE_Index
ReDim Preserve GlobQueueDepository(W_QE_Index)


'=====================================================================================================================================
'   MOVE TO DEPOSITORY
'-------------------------------------------------------------------------------------------------------------------------------------
With GlobQueueDepository(W_QE_Index)
.Interaction = AInteraction
.First = WArray(1): .FirstStatus = Wstatus(1)
.Second = ""
.Third = ""
.Fourth = ""
.FourthStatus = c__PlainText

If TokensNumber > 1 Then
  .Second = WArray(2)
  If TokensNumber > 2 Then
     .Third = WArray(3)
     If TokensNumber > 3 Then
        .Fourth = WArray(4)
        .FourthStatus = Wstatus(4)
     End If
  End If
End If
.StateShift = ShiftForState
'=====================================================================================================================================
End With
If deb Then Action_to_panel GlobQueueDepository(W_QE_Index)

End Sub


Public Function proc_Instruction() As Boolean

Dim ws$, wi&, WII&, WDebug$
Dim WSize&, WJ&
Dim WQue As CommonQueue
Dim WEndRecognizing&
Dim CASED_eo_token$
Dim CASED_es_list$, CASED_es_token$
Dim W_es_type$
Dim eo_RecognizedIndex&
Dim WFirst$, WFirstStatus$, WSecond$
Dim loVarIx&


On Error GoTo he

If flag_TEXT_STOPPED Then Exit Function

proc_Instruction = True
DlgNm = (DlgNm + 1 Mod 400000000)

'===========================================
If deb Then moPr.Dialog_to_panel False
'===========================================

eo_RecognizedIndex = 0      'simplify things;
WEndRecognizing = es_EvStatementsNumber

'---------- complications with Recognition Forks --------------------------------------------
'Dim WStartRecognizing&
'WStartRecognizing = 1
'can not save this time easily because if "nest . ... " goes before "moo .10 ... "
'then "." will be not caught ..."
'If eo_RecognizedIndex > 0 Then
   '"save the time": eo_RecognizedIndex is recognized for sure:
        'WEndRecognizing = eo_RecognizedIndex
   'kk.needs work: above string causes to miss mistakenly recognized
   'event .21 because it was global and tokenizer set its index as recongized
   'in non-current state, so .21 was not recognized here;
        'WEndRecognizing = es_EvStatementsNumber
'Else
'WEndRecognizing = es_EvStatementsNumber
'End If
'---------- ef complications with Recognition Forks --------------------------------------------


'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
For wi = 1 To WEndRecognizing   '    R E C O G N I Z E    A N    E V E N T
'N O    I N D E N T   F O R     F O R
'===========================================================================================
WSize = es_nest_size(wi)                        'event-statement nest size;
If dlgPs < WSize Then GoTo StillNotRecognized   'not enough states in global nest to match this event;
W_es_type = es_type(wi)
'quick check:

'Preliminary type check:
Select Case W_es_type
Case moTz.eo_type, e__ANY, e__LIST_QUESTION, e__LIST_VARIABLE: GoTo ContinueB
Case Else:
     If ":" = Left(W_es_type, 1) Then
        If InStr(W_es_type, moTz.eo_type) > 0 Then
           W_es_type = moTz.eo_type
           'Union of types
           GoTo ContinueB
        End If
     End If
     GoTo StillNotRecognized
End Select

ContinueB:
'kk.later: e_MANY_STATES
For WJ = 1 To WSize
    If es_nest(wi, WJ) <> g_nest(dlgPs - WSize + WJ) And _
       es_nest(wi, WJ) <> si__ Then GoTo StillNotRecognized
    DoEvents
Next


'TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
'     All states in event-nest matched global nest "tail" now. Try to match event-patterns:
'============================================================================================
Select Case W_es_type
     
     Case e__ANY
     
        If e__EXC = moTz.eo_type Then GoTo StillNotRecognized
        eo_RecognizedIndex = wi
        If deb Then moPr.prn_NSI "r e c o g n i z e d   a s  ANY event as #" & _
           eo_RecognizedIndex
        GoTo StoreActions
     
     Case moTz.eo_type               'TYPES MATCH EACH OTHER
        'assembly event-statement word if it string with undefined shortcuts;
        If es_NO_ESCAPES(wi) Then
            CASED_es_token = es_token(wi)
        Else
            CASED_es_token = moVr.var_SubstituteShortCuts(es_token(wi))
        End If
        CASED_eo_token = moTz.eo_token
        Select Case moTz.eo_type
           Case e__SEPARATOR
                If Not moTz.env_separator_case_sensetive Then
                   CASED_es_token = LCase(CASED_es_token)
                   CASED_eo_token = LCase(CASED_eo_token)
                End If
           Case e__KEYWORD
                If Not moTz.env_keyword_case_sensetive Then
                   CASED_es_token = LCase(CASED_es_token)
                   CASED_eo_token = LCase(CASED_eo_token)
                End If
           Case e__WORD
                If Not env_word_case_sensetive Then
                   CASED_eo_token = LCase(CASED_eo_token)
                   CASED_es_token = LCase(CASED_es_token)
                End If
           Case e__IDENTIFICATOR
                If Not env_p_id_is_case_sensetive Then
                   CASED_eo_token = LCase(CASED_eo_token)
                   CASED_es_token = LCase(CASED_es_token)
                End If
        End Select
        
        'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
        '   WORDS MATCH
        '==================================================================================
        If CASED_es_token = CASED_eo_token Or CASED_es_token = "" Then
            'Final match point: now, not only types match, but words also match;
            eo_RecognizedIndex = wi
            If deb Then moPr.prn_NSI "r e c o g n i z e d   a s  #" & eo_RecognizedIndex
            GoTo StoreActions
        End If
        'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
     
  Case e__LIST_VARIABLE
       'be strict at from the beginning: allow only two types to be in the list:
       If moTz.eo_type = e__WORD Or moTz.eo_type = e__IDENTIFICATOR Then                'only words will be tested against the list;
          If Not env_word_case_sensetive Then
                'vl to secure:
                CASED_es_list = alph__ListVariableSeparator & LCase(moVr.var_Get(es_token(wi)))
                CASED_eo_token = LCase(moTz.eo_token)
          Else
                'vl to secure:
                CASED_es_list = alph__ListVariableSeparator & moVr.var_Get(es_token(wi))
                CASED_eo_token = moTz.eo_token
          End If
          'schema:   "....^...vl...."  ---> "....^^...^\..." & vl
          CASED_eo_token = alph__ListVariableSeparator & Replace( _
                Replace(CASED_eo_token, alph__ListVariableEscape, _
                alph__ListVariableEscape & alph__ListVariableEscape), _
                alph__ListVariableSeparator, alph__ListVariableEscape & alph__ListVariableHiddenSeparator _
                ) & alph__ListVariableSeparator
          If InStr(CASED_es_list, CASED_eo_token) > 0 Then
                eo_RecognizedIndex = wi
                If deb Then moPr.prn_NSI "r e c o g n i z e d   a s  #" & eo_RecognizedIndex
                GoTo StoreActions
          End If
       End If
  Case e__LIST_QUESTION
  
       If moTz.eo_type <> e__SEPARATOR Then
          'Only words will be tested against the list.
          
          If 0 = Len(moTz.eo_token) Then GoTo StillNotRecognized
          loVarIx = moVr.var_GetIndexVerify(es_token(wi))
          If 0 = loVarIx Then GoTo StillNotRecognized
          
          If env_word_case_sensetive Then
             'CASED_eo_token = vbLf & LCase(eo_token) & " "
             mEsLIST_QUESTION_Start = InStr(moVr.varValues(loVarIx), _
                                       vbLf & moTz.eo_token & " ")
          Else
            'kk.do extremely slow: make it low case before run-time:
             mEsLIST_QUESTION_Start = InStr(LCase(moVr.varValues(loVarIx)), _
                                             vbLf & LCase(moTz.eo_token) & " ")
          End If
          
          If mEsLIST_QUESTION_Start > 0 Then
             eo_RecognizedIndex = wi
             
             glEsLIST_QUESTION_Ix = loVarIx
             mEsLIST_QUESTION_Start = mEsLIST_QUESTION_Start + _
                                       Len(moTz.eo_token) + 2

             If deb Then moPr.prn_NSI "r e c o g n i z e d   a s  #" & eo_RecognizedIndex
             GoTo StoreActions
          
          End If
       
       End If
End Select
'TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT


StillNotRecognized: DoEvents
'===========================================================================================
Next    ' ef OF THE RECOGNITION BLOCK
'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR





'=============================================================================
'       ef      R E C O G N I Z E    A N    E V E N T
RecongitionFullFailure:
 
Select Case moTz.eo_type
  Case "bof"
       If deb Then moPr.PrintNL "Beginning-Of-Folder was not recongized"
  Case "eof"
       If deb Then moPr.PrintNL "End-Of-Folder was not recongized"
  Case e__BOT
       If deb Then moPr.PrintNL "Beginning-Of-Text was not recongized"
  Case e__BOP
       If deb Then moPr.PrintNL "Beginning-Of-Project was not recongized."
  Case e__EOP
       If deb Then moPr.PrintNL "End-Of-Project event was not recongized."
       flag_TEXT_STOPPED = True
  Case e__EOT
       If deb Then moPr.PrintNL "End-Of-Text event was not recognized in Dialog."
       'there one more "loose" for programmer
       'this: flag_TEXT_STOPPED = True replaced by .exc event
       'in tokenizer
  Case e__EXC
       moPr.PrintNL moTz.eo_token
       flag_TEXT_STOPPED = True
  Case Else
       moXc.FilterSourceException _
          E_warn, _
          "UNRECOGNIZED EVENT", _
          "", _
          "proc_Instruction"
End Select
TerminateDialog:
Exit Function '|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
'=============================================================================










'================================================================================
StoreActions:       'A D D I N G   I N T O   T H E    Q U E U E:
'================================================================================
If es_post_beginning(eo_RecognizedIndex) = 0 Then GoTo SkippedStoringActions

'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
'       License protection
'===============================================================================
'===============================================================================
'EndOfLicenseProtection: '   ef License protection
'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm



'do not forget: fist came --> must be first at the end: so, change an order: -1;

For wi = es_post_end(eo_RecognizedIndex) To es_post_beginning(eo_RecognizedIndex) Step -1
    Ubound_g_que = Ubound_g_que + 1
    If Ubound_g_que_M < Ubound_g_que Then e_stop "No space in global queue."
        
    'this may be fast, but does not keep .d :
    '"build up" the global queue as a sequence of indexes:
    'g_que(Ubound_g_que) = WI
    
    'to preserve .d - events, make g_que string var.
    'pull initial expressions from storage to make following
    'substitutions:
    'this is a generic operation used for actions and states:
    g_que_Comm(Ubound_g_que) = GlobQueueDepository(wi)
       
    'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
    '   For events:
    '==========================================================================
    'KK.perhaps slow:
    With g_que_Comm(Ubound_g_que)
    If salph__Event <> .Interaction Then GoTo EventCompleted
    
             If .FirstStatus = c__Variabled Then
                .First = moVr.var_SubstituteShortCuts(.First)
                .FirstStatus = c__QuotedText
             ElseIf .First = "" And .FirstStatus = c__PlainText Then
                .First = moTz.eo_token
             End If
             'no fourth cluster-elements jet implemented.
             
'========================================================================
'            This is done on ParseSchema level.
'             If .Second = "" Then
'                .Second = e__SEPARATOR
'                'this will be interesting: .Second = motz.eo_type
'             ElseIf .Second = e__DEFERRED Then         'deferred
'========================================================================
             If .Second = e__DEFERRED Then              'deferred
                'case +.d; make it +
                .Interaction = salph__Event
                .First = moTz.eo_token
                .Second = moTz.eo_type
                .FirstStatus = c__PlainText
                .FourthStatus = c__PlainText
             End If
     End With

     If e__EXC = GlobQueueDepository(wi).Second Then
        'fire exception
        WFirst = g_que_Comm(Ubound_g_que).First
        WFirstStatus = g_que_Comm(Ubound_g_que).FirstStatus
        Ubound_g_que = Ubound_g_que - 1
        moXc.FilterSourceException _
           E_warn, _
           WFirst, _
           "", _
           "proc_Instruction"
     End If
     
EventCompleted:
     If Ubound_g_que > MaximumQueue Then MaximumQueue = Ubound_g_que
     'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
         
     '==================================================
     If deb Then    'D E B U G G I N G
                    'this is good because
                    'does not repeat at each dialog step
        If ddeb Then ws = "(" & Ubound_g_que & ")" Else ws = ""
        moPr.prn_NSI "  TO QUEUE: " & ws
        Action_to_panel g_que_Comm(Ubound_g_que)
     End If
     
     '==================================================
     DoEvents
'=========================================================================
Next
'=========================================================================

SkippedStoringActions: Exit Function


'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
he:
xNo = Err.Number
xMe = Err.Description
Resume xNext
xNext: On Error GoTo 0
moXc.FilterSourceException xNo, xMe, espot, "proc_Instruction"
'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

End Function




'
'
'MUST: Ubound_g_que > 0
'
'||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
Public Function proc_Queue() As Boolean

Const BeyondMsg$ = "Action takes bytes from position beyond text end." & vbCrLf & "Position is "
Dim gQue As CommonQueue
Dim CommQue As CommonQueue
Dim TextToOutput$
Dim gQueFirst$, gQueFourth$, WSecond$

Dim gQueResultedFirstStatus$
Dim gQueResultedFourthStatus$
Dim WFrom$, WTo$       'for conversion

Dim wi&, WII&, ws$, WSS$
Dim WFirstCharInSecond$
Dim WVariableName$


'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
RepeatQueue:   'S T A R T   O F
               'L O C A L - Q U E U E   L O O P
'======================================================

On Error GoTo he

'needed for infinite loop protection and for debug:
If watchTerminateText Then Exit Function

Select Case oCondition
   Case "1":   oCondition = ""
               If 1 > Ubound_g_que Then Exit Function
               gQue = g_que_Comm(Ubound_g_que)
               Ubound_g_que = Ubound_g_que - 2

   Case "2":   oCondition = ""
               If 1 > Ubound_g_que Then Exit Function
               gQue = g_que_Comm(Ubound_g_que - 1)
               Ubound_g_que = Ubound_g_que - 2
   
   Case Else:  If 1 > Ubound_g_que Then Exit Function
               gQue = g_que_Comm(Ubound_g_que)
               Ubound_g_que = Ubound_g_que - 1
End Select

   
   
   '==================================================
   ' D E B U G G I N G
   '--------------------------------------------------
   If deb Then
      moPr.prn_NSI "NEST= " & moPr.GlobalNest_to_display()
      moPr.prn_NSI "  PROCESSING: "
      Action_to_panel gQue
   End If
  '===================================================



If gQue.Interaction <> salph__StateEsc And _
   gQue.Interaction <> ialph__AbsStateEsc Then _
   GoTo Run_Time_DeEscaping
   

'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
'  S T A T E   P R O C E S S I N G
'================================================================
With gQue

   If ialph__AbsStateEsc = gQue.Interaction Then
      '----------------------------------------------------------
      'absolute positioning:
      dlgPs = .StateShift
      '----------------------------------------------------------
   Else
   
      wi = dlgPs + .StateShift
      If wi > 1000000 Then
         e_stop "Nest is greater than 1000000."
      End If
      dlgPs = wi      'advancing nest cursor;
      
   End If
   If dlgPs > rtNestDimension Then
      rtNestDimension = dlgPs
      ReDim Preserve g_nest(rtNestDimension)
      ReDim Preserve g_NestVariable(rtNestDimension)
      'moVr.ExtendLevelVariable 'do1 wis?
   End If
   If dlgPs < 1 Then dlgPs = 1
   If .Numberr = 0 Then
      'kk.deferred: eliminate later:
      e_stop "Bug in Compi: Unindexed State."
   End If
   If .Numberr <> si__ Then g_nest(dlgPs) = .Numberr
   
End With
'statistics:
If dlgPs > MaximumNest Then MaximumNest = dlgPs
GoTo RepeatQueue
'----------------------------------------------------------------
' ef  S T A T E   P R O C E S S I N G
'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS







'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
'  CONTINUE ACTIONS And EVENTS
'================================================================
'  Events are  handled in the main body.
'  Actions are handled in GoSub.
'----------------------------------------------------------------


'================================================================
Run_Time_DeEscaping:
'----------------------------------------------------------------
With gQue

If .FirstStatus = c__Variabled Then
   gQueFirst = moVr.var_SubstituteShortCuts(.First)
   'kk.later: this is no a perfect solution:
   gQueResultedFirstStatus = c__QuotedText
Else
   'kk.slow:
   gQueFirst = .First
   gQueResultedFirstStatus = .FirstStatus
End If

If .FourthStatus = c__Variabled Then
    'deescape fourth:
    gQueFourth = moVr.var_SubstituteShortCuts(.Fourth)
    'command parameter needs history of string:
    gQueResultedFourthStatus = c__QuotedText
Else
    'kk.slow:
    gQueFourth = .Fourth
    gQueResultedFourthStatus = .FourthStatus
End If
End With
'================================================================




Select Case gQue.Interaction
   


'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
'  P R O C E S S I N G    E V E N T
'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
Case salph__Event, salph__Late_Event:
    
With gQue
      
 If .Interaction = salph__Late_Event And _
    (.Second = e__SKIP_TOKEN Or _
     .Second = e__SKIP_RECOGNITION) Then
            
    Select Case .Second
           Case e__SKIP_TOKEN
                'stash event:
                ws = moTz.eo_token
                WSS = moTz.eo_type
                moTz.FindToken "", False
                'restore event:
                moTz.eo_token = ws
                moTz.eo_type = WSS
           Case e__SKIP_RECOGNITION
                moTz.FindToken "", False
    End Select
      
 Else
     
    'this leaves a possibility to leave eo_token unchanged:
    If .Interaction = salph__Event Or gQueFirst <> "" Or _
       gQueResultedFirstStatus = c__QuotedText Then _
       moTz.eo_token = gQueFirst
    moTz.eo_type = .Second
    If moTz.eo_type = e__ANY Then moTz.FindToken "", False
    
    
    
    
    'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
    proc_Instruction   'THE ONLY CALL TO DIALOG IN THIS PROC.
    'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
    
    
    
    If watchTerminateText Then Exit Function
      
End If
End With
'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm

   

Case salph__Action: GoSub PerformAction
'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM


Case Else: e_stop "Unknown convert-time action `" & _
                  gQue.Interaction & "`."
End Select
GoTo RepeatQueue
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX













'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
PerformAction:        'R P O C E S S I N G   A C T I O N
                      'GoSub Block.
'===================================================================
'Select Case motz.eo_type
'Case e__IDENTIFICATOR, e__WORD, e__NUMBER, e__KEYWORD, e__SEPARATOR
With gQue

WSecond = .Second

'NONE-ACTION:
If WSecond = aR__NONE Then GoTo CommandCompleted

WFirstCharInSecond = Left(WSecond, 1)
Select Case WFirstCharInSecond
   Case aR__OUTPUT_TOKEN, aR__PRINT_TOKEN, aR__OUTPUT_TO_CONSOLE, _
        "L", "U", "T", "I", aR__ASSIGN_TO_VARIABLE
        '.& .&& .~ .... "="
   Case "0"
        Ubound_g_que = 0    'easy queue cleanup;
        oCondition = ""     'clears all stuff related to conditions;
        GoTo CommandCompleted
   Case "1"                 'clean queue and its garbage;
        CleanQueueAndCondition
        GoTo CommandCompleted
   'convenient place:
   'MORE cases can be added here:
   'case ...
   Case Else
        GoTo SkippedOutputTextPreparation
End Select
'oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
'   OUTPUT OF THE PLAIN TEXT: the only case when second = or == or ~;
'======================================================================
' DECIDE TOKEN ON TEXT TO SUBMIT:
'----------------------------------------------------------------------
If gQueFirst = "" And .FirstStatus = c__PlainText Then
  'EMPTY FIRST PART: TOKEN "IS WANTED TO BE PRINTED":
  
  'garbage:
  'manipulate with case:
  'If motz.eo_type <> e__STRING And motz.eo_type <> e__NUMBER Then
  '  Select Case env_output_case
  '    Case "L": TextToOutput = LCase(eo_token)
  '    Case "U": TextToOutput = UCase(eo_token)
  '    Case Else: TextToOutput = eo_token
  '  End Select
  'Else
  'string never changes its case:
  
  TextToOutput = moTz.eo_token
  
  'End If
Else
  '<first level text>.= or <flt>. or <flt>.== or <flt>..moo or ...
  TextToOutput = gQueFirst
End If
'======================================================================




'======================================================================
'SELECT DESTINATION AND MAKE SUBMISSION
'----------------------------------------------------------------------
Select Case WFirstCharInSecond
    
    '--------------------------------------------------------
    'wrapping to some VB functions
    Case "U", "L", "T"
        Select Case WFirstCharInSecond
               Case "U": TextToOutput = UCase(TextToOutput)
               Case "L": TextToOutput = LCase(TextToOutput)
               Case "T": TextToOutput = Trim(TextToOutput)
        End Select
        If .Third <> "" Then
            moVr.var_Set .Third, TextToOutput
        Else
            moTz.eo_token = TextToOutput
        End If
        GoTo CommandCompleted
    '--------------------------------------------------------
    
    Case aR__ASSIGN_TO_VARIABLE:  GoTo AssignmentsToVariable

End Select

Select Case WSecond
    Case aR__OUTPUT_TOKEN, "I"           '.&
         Select Case WSecond
              Case aR__OUTPUT_TOKEN
                   TextToOutput = Indent_Replacer & TextToOutput
              Case Else
                   moPc.MakeIndentReplacer
                   TextToOutput = Indent_Replacer
         End Select
         If StreamsOpen = 0 Then
            moPr.add_ConvertedFragmentToResult TextToOutput
         Else
            moVr.var_AddToStreams TextToOutput
         End If
    Case aR__PRINT_TOKEN            '.&&
         TextToOutput = Indent_Replacer & TextToOutput
         moPr.add_ConvertedFragmentToResult TextToOutput
         moVr.var_AddToStreams TextToOutput
    Case aR__OUTPUT_TO_CONSOLE      '~
         'why this garbage?:
         'TextToOutput = Indent_Replacer & TextToOutput
         moPr.OUTO_Console TextToOutput
    Case Else: GoTo AssignmentsToVariable
         
End Select
'clean up indenter:
Indent_Replacer = ""
GoTo CommandCompleted
'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
    
'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
AssignmentsToVariable:    ' action:  moo.=MyVariable or
'                           "$x ".=  (to assign to the token);
'                           or action with replacement;
'=====================================================================
WVariableName = Mid(WSecond, 2)
If WVariableName = "" Then WVariableName = varn_TOKEN
If .Third <> "" Then
      '  text.=variable.replacee.replacer   or
      'TextToOutput.=.replaceee.replacer:
      'minor bug fix: use of gQueFourth instead of .Forth:
      TextToOutput = Replace(TextToOutput, .Third, gQueFourth)  '.Fourth)
End If
moVr.var_Set WVariableName, TextToOutput
GoTo CommandCompleted
'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa



SkippedOutputTextPreparation:
Select Case WSecond
    Case aR__INDENT: moPc.MakeIndentReplacer
    Case aR__STREAM_ON, aR__STREAM_ON_AND_EMPTY
         If .Third <> "" Then
             wi = moVr.var_GetIndex(.Third)
             'if index did not exist, var. is initiated;
             'was this stream handled?:
             For WII = 1 To UBound(OpenStreams)
                    If OpenStreams(WII) = wi Then
                       'do not change anything; its already open;
                       GoTo ExitStreamsOn
                    End If
             Next
             'no, it is not open
             StreamsOpen = StreamsOpen + 1
             ReDim Preserve OpenStreams(StreamsOpen)
             OpenStreams(StreamsOpen) = wi
             If deb Then moPr.prn_NSI "opening stream " & moVr.var_GetNameByIndex(wi)
             If WSecond = aR__STREAM_ON_AND_EMPTY Then _
                moVr.var_SetByKnownIndex wi, ""
          End If
ExitStreamsOn:
'~ ~ ~ ~ ~ continue by case of second cluster fragment:
    Case aR__STREAM_OFF
    
         '-----------------------------------------------------------
         If .Third = "" Then     '   stop all streams:
         '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
             'disable all streams
             StreamsOpen = 0
             ReDim OpenStreams&(0)
             If deb Then moPr.prn_NSI "all streams have been closed;"
         '-----------------------------------------------------------
         Else                   '    close stream .Third
         '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
             wi = moVr.var_GetIndex(.Third)
             'was this stream handled?:
             For WII = 1 To UBound(OpenStreams)
                    If OpenStreams(WII) = wi Then
                       OpenStreams(WII) = 0
                       If deb Then moPr.prn_NSI "stream " & Trim(moVr.var_GetNameByIndex(wi)) & " closed;"
                       StreamsOpen = StreamsOpen - 1
                       If StreamsOpen = 0 Then ReDim OpenStreams(0)
                       GoTo ExitStreamsOff
                    End If
             Next
         End If
         '-----------------------------------------------------------
ExitStreamsOff:
   
    'kk.later: make a continue-on-the-next-file option;
    Case aCRP__END_TEXT, aCRP__END_TEXT2:
                
                'this is a normal text end:
                flag_TEXT_STOPPED = True
                'mopr.prn_NSI ve & "TERMINATING TEXT (FILE)"
           
    Case aCRP__STOP: moAc.flag_PROJECTS_STOPPED = True
                     flag_TEXT_STOPPED = True
    Case aR__COMPILE_SCHEMA
                 'TEXT IS ASSUMED THAT SCHEMA IS IN EVENTS-STATEMENT LIST
                 moPr.PrintNL ve & "C O M P I L I N G   S C H E M A"
                 moTz.parse_Schema_psc
                 moPr.PrintNL "S C H E M A   C O M P I L E D" & ve
    Case aR__COMPILE_PROJECT
    Case aR__PROGRAM
     
         If moPc.proc_Program(.Third, gQueFourth, gQueResultedFourthStatus) _
            Then GoTo CommandCompleted
         If moPc.proc_Command(.Third, gQueFourth, gQueResultedFourthStatus) _
            Then GoTo CommandCompleted
         moPc.Procedure1_custom .Third, gQueFourth              ' run subroutines
         
'~ ~ ~ ~ ~ continue by case of second cluster fragment:
    
    Case "<":        moTz.muPsn = moTz.FormerTextPosition
        
    Case aR__CHAR:   On Error Resume Next
                     If .First <> "" Then moTz.muPsn = CLng(.First)
                     If Err.Number > 0 Then GoTo ByteOperationExceptionHandler
                     
                     If moTz.muPsn > Len(moTz.MSourceText) Then e_raise BeyondMsg$ & moTz.muPsn
                     moTz.eo_token = Mid(moTz.MSourceText, moTz.muPsn, 1)
                     moTz.muPsn = moTz.muPsn + 1
                     
                     
    Case aR__BYTE:    On Error Resume Next
                     If .First <> "" Then moTz.muPsn = CLng(.First)
                     If Err.Number > 0 Then GoTo ByteOperationExceptionHandler
                     
                     If moTz.muPsn > Len(moTz.MSourceText) Then e_raise BeyondMsg$ & moTz.muPsn
                     moTz.eo_token = CStr(Asc(Mid(moTz.MSourceText, moTz.muPsn, 1)))
                     moTz.muPsn = moTz.muPsn + 1
                    
    
    Case aR__2CHARS: On Error Resume Next
                     If .First <> "" Then moTz.muPsn = CLng(.First)
                     If Err.Number > 0 Then GoTo ByteOperationExceptionHandler
                     
                     If moTz.muPsn + 1 > Len(moTz.MSourceText) Then e_raise BeyondMsg$ & moTz.muPsn
                     moTz.eo_token = Mid(moTz.MSourceText, moTz.muPsn, 2)
                     moTz.muPsn = moTz.muPsn + 2
                    
                     
    Case aR__WORD:   'take word in normal order:
                     On Error Resume Next
                     If .First <> "" Then moTz.muPsn = CLng(.First)
                     If Err.Number > 0 Then GoTo ByteOperationExceptionHandler
                     
                     If moTz.muPsn + 1 > Len(moTz.MSourceText) Then e_raise BeyondMsg$ & moTz.muPsn
                     moTz.eo_token = CStr(256& * Asc(Mid(moTz.MSourceText, moTz.muPsn, 1)) + _
                                Asc(Mid(moTz.MSourceText, moTz.muPsn + 1, 1)))
                     moTz.muPsn = moTz.muPsn + 2
                     
    Case aR__BWORD:  'take word in normal low_is_first order:
                     On Error Resume Next
                     If .First <> "" Then moTz.muPsn = CLng(.First)
                     If Err.Number > 0 Then GoTo ByteOperationExceptionHandler
                     
                     If moTz.muPsn + 1 > Len(moTz.MSourceText) Then e_raise BeyondMsg$ & moTz.muPsn
                     moTz.eo_token = CStr(Asc(Mid(moTz.MSourceText, moTz.muPsn, 1)) + _
                                256& * Asc(Mid(moTz.MSourceText, moTz.muPsn + 1, 1)))
                     moTz.muPsn = moTz.muPsn + 2
                     
                    
    Case aR__BLWORD: 'take word in normal order:
                     On Error Resume Next
                     If .First <> "" Then moTz.muPsn = CLng(.First)
                     If Err.Number > 0 Then GoTo ByteOperationExceptionHandler
                     If moTz.muPsn + 3 > Len(moTz.MSourceText) Then e_raise BeyondMsg$ & moTz.muPsn
                     wi = Asc(Mid(moTz.MSourceText, moTz.muPsn + 3, 1))
                     WII = wi Mod 128
                     WII = 256& * 256& * 256& * WII + _
                           256& * 256& * _
                           Asc(Mid(moTz.MSourceText, moTz.muPsn + 2, 1)) + _
                           256& * Asc(Mid(moTz.MSourceText, moTz.muPsn + 1, 1)) + _
                           Asc(Mid(moTz.MSourceText, moTz.muPsn, 1))
                     If wi > 127 Then WII = -WII
                     moTz.eo_token = CStr(WII)
                     moTz.muPsn = moTz.muPsn + 4
                        
                     
    Case aR__LWORD:  'take word in normal low_is_first order:
                     On Error Resume Next
                     If .First <> "" Then moTz.muPsn = CLng(.First)
                     If Err.Number > 0 Then GoTo ByteOperationExceptionHandler
                     If moTz.muPsn + 3 > Len(moTz.MSourceText) Then e_raise BeyondMsg$ & moTz.muPsn
                     wi = Asc(Mid(moTz.MSourceText, moTz.muPsn, 1))
                     WII = wi Mod 128
                     WII = 256& * 256& * 256& * WII + _
                           256& * 256& * Asc(Mid(moTz.MSourceText, moTz.muPsn + 1, 1)) _
                           + 256& * Asc(Mid(moTz.MSourceText, moTz.muPsn + 2, 1)) + _
                           Asc(Mid(moTz.MSourceText, moTz.muPsn + 3, 1))
                     If wi > 127 Then WII = -WII
                     moTz.eo_token = CStr(WII)
                     moTz.muPsn = moTz.muPsn + 4
     
    
    Case aR__UPTO:   On Error Resume Next
                     If gQueFirst = "" Then
                        espot = "Empty ""UpTo"" character or string."
                        GoTo ByteOperationExceptionHandler
                     End If
                     moTz.FindToken gQueFirst, True
                     If Err.Number > 0 Then GoTo ByteOperationExceptionHandler
                     
    Case aR__NONE:   'do none; empty action;
    

    Case Else
    
'~ ~ ~ ~ ~ continue by case of second cluster fragment:
         
         If InStr(WSecond, aR__TAKE_STRING) = 1 Then
            
            ws = Mid(WSecond, Len(aR__TAKE_STRING) + 1)
            'take string from position
            On Error Resume Next
            wi = CLng(ws)
            If Err.Number > 0 Then GoTo ByteOperationExceptionHandler
            If .First <> "" Then moTz.muPsn = CLng(.First)
            If Err.Number > 0 Then GoTo ByteOperationExceptionHandler
            If moTz.muPsn + 1 > Len(moTz.MSourceText) Then e_raise BeyondMsg$ & moTz.muPsn
            If wi < 0 Or wi + moTz.muPsn > Len(moTz.MSourceText) + 1 Then _
               e_raise BeyondMsg$ & moTz.muPsn & ", or " & ve & _
               "incorrect number of characters " & wi
            moTz.eo_token = Mid(moTz.MSourceText, moTz.muPsn, wi)
            moTz.muPsn = moTz.muPsn + wi
         
         ElseIf "%" = Left(WSecond, 1) Then
            'convert
            WFrom = Mid(WSecond, 2, 1)
            WTo = Mid(WSecond, 3, 1)
            
            Select Case WFrom
                Case "c": wi = Asc(Left(moTz.eo_token, 1))
                Case "o", "h"
                     ws = moTz.eo_token
                     If Left(moTz.eo_token, 1) <> "&" Then
                        ws = "&" & UCase(WFrom) & ws
                     End If
                     wi = val(ws)
                Case "d": wi = CLng(moTz.eo_token)
            End Select
            Select Case WTo
                Case "c":  ws = Chr(Abs(wi) Mod 256)
                Case "d":  ws = CStr(wi)
                Case "h":  ws = "conversion to hexadecimal is not done"
                Case "o":  ws = "conversion to octal is not done"
                Case Else: ws = "this conversion is not done"
            End Select
            If .Third <> "" Then moVr.var_Set .Third, ws Else moTz.eo_token = ws
         Else
    
           'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
           xNo = E_stopp
           xMe = "Unknown action type: '" & WSecond & "'"
           
           moXc.ReportAndClassifyException xNo, xMe, espot, "proc_Queue"

           moPr.prn_NSI ve & "A c t i o n : "
           Action_to_panel gQue
           moPr.PrintNL ""
           'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
         
         End If  'If "#" = Left(WSecond, 1) Then
End Select
CommandCompleted:
End With
Return
'=====================================================================
' ef  P R O C E S S I N G   A C T I O N S
'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA






he:  'hehehehehehehehehehehehehehehehehehehehehehehehehehehehehehehehe

       xNo = Err.Number
       xMe = Err.Description
       Resume xNext
   
xNext: On Error GoTo 0
       moXc.FilterSourceException xNo, xMe, espot, "proc_Queue"
       If xNo = E_warn Then
          'exc was raised; go and dialog with it
          GoTo RepeatQueue
       End If
       'moex.ReportAndClassifyException xNo, xMe, espot, "proc_Queue"
      
Exit Function
'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx



'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
ByteOperationExceptionHandler:
       xNo = E_think
       xMe = "Original exc. " & Err.Number & " " & Err.Description & _
             ve & "in Compi's byte operations."
       Resume xNext
'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx



End Function

'DESCRIPTION:
'Puts event on the top of global queue.
'Event taken from depository.
'Event is not modified.
'
Private Sub PushEvent_ByIndexFromDepository(EventDepositoryIndex&)
Ubound_g_que = Ubound_g_que + 1
If Ubound_g_que_M < Ubound_g_que Then e_stop "no space in global-queue"
'we need to set two variables:
'g_que(Ubound_g_que) = EventDepositoryIndex
g_que_Comm(Ubound_g_que) = GlobQueueDepository(EventDepositoryIndex)
End Sub


'Parts of formerly Print Class
'
'


Public Sub print_ES(EvN&)
Dim wi&, ws$

'If Not moDlg.deb Then Exit Sub
If EvN > es_EvStatementsNumber Then _
   e_stop "Event number is greated than events' quantity."
If EvN > Ubound_es_M Then _
   e_stop "Event number is greated than Ubound_es_M."

moPr.PrintL ""
moPr.PrintL "EVENT-STATEMENT " & EvN
moPr.PrintS "     nest  "
ws = ""
For wi = 1 To es_nest_size(EvN)
    If ddeb Then ws = ws & es_nest(EvN, wi) & ":"
    ws = ws & moTz.StateNameStr(es_nest(EvN, wi)) & "      "
    DoEvents
Next
moPr.PrintL ws
moPr.PrintS "  pattern  "

moPr.PrintS moPr.TokenString_for_display(es_token(EvN)) & _
       salph__ClusterSeparator & es_type(EvN)

If Not es_NO_ESCAPES(EvN) Then moPr.PrintS "/V"

moPr.PrintL ""
moPr.PrintS "    scope  "
moPr.PrintS es_global_type(EvN)

If es_post_beginning(EvN) > 0 Then
   moPr.PrintL ""
   moPr.PrintS "    queue  "
   If ddeb Then
      moPr.PrintS " :" & es_post_beginning(EvN) & "::::" & es_post_end(EvN) & ":"
   End If
   For wi = es_post_beginning(EvN) To es_post_end(EvN)
       moPr.PrintL LossySlash(Action_for_display(GlobQueueDepository(wi), moTz))
       DoEvents
   Next
End If
moPr.PrintL " "

End Sub


Public Sub proc_SlideEvent_Modify(FirstSubElement$, SecondSubElement$)
Dim I&

Ubound_g_que = Ubound_g_que + 1
If Ubound_g_que_M < Ubound_g_que Then e_stop "no space in global-queue"

                                   
If Ubound_g_que > 1 Then             'values;
  For I = Ubound_g_que To 2 Step -1
      g_que_Comm(I) = g_que_Comm(I - 1)
  Next
End If

With g_que_Comm(1)
    'g_que(Ubound_g_que)
    .Interaction = salph__Event
    .First = FirstSubElement
    .Second = SecondSubElement
    .Third = ""
    .Fourth = ""
    .FirstStatus = c__PlainText
    .FourthStatus = c__PlainText
End With

End Sub


'DESCRIPTION:
'Adds event to the top of the queue.
'
Public Sub proc_PushEvent_Modify( _
           FirstSubElement$, SecondSubElement$)
Ubound_g_que = Ubound_g_que + 1
If Ubound_g_que_M < Ubound_g_que Then e_raise "no space in global-queue"

'we need to set two variables:
'g_que(Ubound_g_que) = 1            'it is used as flag actually only: -1
                                    'and not -1 are important
                                    'values;
With g_que_Comm(Ubound_g_que)
    'g_que(Ubound_g_que)
    .Interaction = salph__Event
    .First = FirstSubElement
    .Second = SecondSubElement
    .Third = ""
    .Fourth = ""
    .FirstStatus = c__PlainText
    .FourthStatus = c__PlainText
End With

End Sub




Public Sub PushEvent(EventText$, EventType$)

proc_PushEvent_Modify EventText, EventType

End Sub



'NOTE:
'it is sufficient to use: proc_PushEvent_Modify for .bot
'no real need to store;
'
'
Public Sub StoreElementInDepository(salph__Element$, Sub1$, Sub2$, Sub3$, Sub4$, Stat1$, Stat2$)
Dim DIndex&

DIndex = UBound(GlobQueueDepository) + 1
ReDim Preserve GlobQueueDepository(DIndex)

With GlobQueueDepository(DIndex)
    .Interaction = salph__Element
    .First = Sub1
    .Second = Sub2
    .Third = Sub3
    .Fourth = Sub4
    .FirstStatus = Stat1 'c__plainText
    .FourthStatus = Stat2 'c__plainText
End With

End Sub


Private Sub Class_Initialize()

deb = False
'Set user environment
suspended = False
do_step = False

DlgNm = 0  'Let it have global values trough double-project.
rtNestDimension = 1000
ReDim g_nest(rtNestDimension)
ReDim g_NestVariable(rtNestDimension)

ReDim GlobQueueDepository(0)


End Sub


Private Sub Class_Terminate()

Set moAc = Nothing

Set moXc = Nothing
Set moTz = Nothing
Set moPc = Nothing
Set moPr = Nothing
Set moVr = Nothing
Set moFt = Nothing

'Set moCr = Nothing

End Sub


