VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CException"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public AllowMessageBox As Boolean

Private moDlg As CDialog
Private moPr As CPrint
Private moVr As CVariables
Private moAc As Acto
Private moTz As CTokenizer
Public Sub SetMoActo(ac As Acto)
Set moAc = ac
End Sub

Public Sub SetMoTokenizer(tz As CTokenizer)
Set moTz = tz
End Sub

Public Sub SetMoVariables(vr As CVariables)
Set moVr = vr
End Sub

Public Sub SetMoPrint(pr As CPrint)
Set moPr = pr
End Sub

Public Sub FilterSourceException(xNo&, xMe$, espot$, ProcName$)
 Dim ws$
 
 ws = ws & GetSituationDescription
 
 ws = ws & "L o c a t i o n   in catching procedure: """ & _
      ProcName & " is: " & ve & espot & ve
 
 If xNo = E_warn Then
 
    ws = "E x c e p t i o n :   " & xMe & ve & ws
    'condition must be reset to add
    '.exc correctly:
    moDlg.resetQueuStreamsConditionIndent
    moDlg.proc_PushEvent_Modify ws, e__EXC
 Else
    ws = "E x c e p t i o n :   " & xNo & " " & xMe & ve & ws
    moDlg.flag_TEXT_STOPPED = True
    If xNo <> E_think Then moAc.flag_PROJECTS_STOPPED = True
    x_Box ws
    moPr.PrintNL ws
 End If
 
End Sub


Public Function GetSituationDescription$()

 Dim ws$, WSS$, wi&, WII&

 Dim textLength&
 textLength = Len(moTz.MSourceText)

 ws = "N e s t :             " & moPr.GlobalNest_to_display() & ve
     ' E x c e p t i o n :   "
 WSS = moPr.Token_for_display
 If Len(WSS) > 200 Then
    WSS = Left(WSS, 200) & "...(token truncated)"
 End If
 
 ws = ws & "E v e n t :           " & _
      WSS & "." & moTz.eo_type & ve

 ws = ws & "P o s i t i o n :     in text: " & moTz.muPsn
          ' E x c e p t i o n :   "
 If 1 > moTz.muPsn Then
    ws = ws & " is undefined. " & ve
 Else

   wi = moTz.muPsn - 150
   If wi < 1 Then wi = 1
   WII = moTz.muPsn - wi
   
   If textLength < WII Then
      If 0 = textLength Then
         ws = ws & " Source text is empty." & ve
      Else
         ws = ws & " is far beyond text end." & ve
      End If
   Else
   
      ws = ws & ve & "L o c a t i o n : " & ve & ve & _
        "======== text fragment is =============" & ve & _
        LossyZero(Mid(moTz.MSourceText, wi, WII + 1)) & _
        "<<< LOCATION <<<<" & _
        LossyZero(Mid(moTz.MSourceText, moTz.muPsn + 1, 150)) & ve & _
        "======== end of text fragment =========" & ve & ve
        
   End If
   
 End If
     
 WSS = moDlg.GloblaQueue_for_display
 If Len(WSS) > 200 Then
    WSS = Left(WSS, 200) & "...(queue truncated)"
 End If
     
 ws = ws & "G l o b a l  Q u e u e : " & WSS & ve
 
 ws = ws & _
      "P r o c e s s i n g  file: " & _
      moVr.var_Get("p_file_for_GUI") & ve
 
 GetSituationDescription = ws
 
End Function


Public Sub ReportAndClassifyException(xNo&, xMe$, espot$, ProcName$)
 Dim ws$

 ws = "E x c e p t i o n :   " & xNo & " " & xMe & ve

 ws = ws & GetSituationDescription
  
 ws = ws & "L o c a t i o n :      in catching procedure """ & _
      ProcName & " is: " & ve & espot & ve
 
 moDlg.flag_TEXT_STOPPED = True
 
 'if this is not very strong exception,
 'it should allow to execute another files:
 If xNo <> E_think Then
    moAc.flag_PROJECTS_STOPPED = True
    x_Box ws
 End If
 moPr.PrintNL ws

End Sub


'displays restricted message;
'must work only for non-web ...
Private Sub x_Box(FullMessage$)
If AllowMessageBox Then MsgBox Left(FullMessage, 1000)
End Sub

Public Sub SetMoDialog(dlg As CDialog)
Set moDlg = dlg
End Sub

Private Sub Class_Terminate()

Set moDlg = Nothing
Set moPr = Nothing
Set moVr = Nothing
Set moAc = Nothing
Set moTz = Nothing

End Sub


