VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Acto"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'---------------------------------------------------------------------------------
'   Interrupt parameters.
Public RESTART_PROJECT_AT_THE_END_flag As Boolean
Public flag_PROJECTS_STOPPED As Boolean
'---------------------------------------------------------------------------------

'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
'   PROJECT GLOBALS

'-----------------------------------------------------
Public Round&                          'Round number of current project.

Private ProcessFromDisk As Boolean
Public SaveResultsToDisk$              'Blocks all disk writings

Public FilesCounter&
Private BytesCounter&                  'Just statistics?
'-----------------------------------------------------
'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP




Public gloProcessedLocalPaths$  'Depository for already executed files in source project.

Private moDlg As CDialog
Private moPc As CProcedure
Private moTz As CTokenizer
Private moXc As CException
Private moPr As CPrint
'Private moCr As CCheckRegistration
Private moDv As CDiskVariables
Private moVr As CVariables
Private moFt As CFolderTree

Private AllowMessageBox As Boolean

'Statistics
Public MillisecondsSinceProjectStart&

'Switches:
Public env_p_variables_when_bot As Long      'Acto
Public env_p_clear_variables_at_eot As Boolean  'Acto
Public env_save_file_mode As Boolean
Public env_no_change_outside_result As Boolean
Public env_SKIP_PROJECT As Boolean

'For exception
Private espot$
Private xMe$, xNo&


Public Function GetProgress&(CurrFileSize_par&, FileInProgress_par$)
GetProgress = moTz.muPsn
CurrFileSize_par = Len(moTz.MSourceText)
FileInProgress_par = moFt.p_file_for_GUI
End Function

Public Function GetVariableByName(vn)
  GetVariableByName = moVr.var_Get(CStr(vn))
End Function

Public Sub Give_Registration_Folder_Path(RegFolder As Variant)

Dim ws$

'moCr.RegistrationFolderPath = RegFolder
'-----------------------------------------------------------------
'license works:
'ws = read_bin_loose(moCr.RegistrationFolderPath & "\" & RegistrationFileName)

'this must be "slightly tested":
'ws = Replace(Replace(Replace(ws, " ", ""), vbCr, ""), vbLf, "")

'moCr.registration_text = moCr.MakeSecondUnEncription(ws)
'-----------------------------------------------------------------

End Sub

Public Sub give_write_method(out_put_object As Variant, WebOrDesk As Variant)

Select Case UCase(CStr(WebOrDesk))
    Case "D":  moPr.SetPrintObject out_put_object
               moPr.DllForDesktop = True
               moPr.OUTO_Console ve & "Compi is ready for console output." & ve
    Case "W":  moPr.DllForDesktop = False
               'without attaching Scripting Library to this project:
               moPr.SetResponseWebObject out_put_object
               moPr.OUT_Raw_To_Web_Console "<br><br><font size=1><a HREF=""http://landkey.net"">Compi</a> is ready for console output.<br><br></font>"
               'see on start page for setting write method;
End Select
AllowMessageBox = moPr.DllForDesktop
moXc.AllowMessageBox = AllowMessageBox

End Sub

'give license text:
Public Function GiveMeMyMaster(s)
'moCr.registration_text = s
Dim dummy
dummy = s
End Function

Public Function MyCopyright$()
   MyCopyright = App.LegalCopyright
End Function

Public Function MyFileDescription$()
   MyFileDescription = App.FileDescription
End Function


Public Function MyVersion()
   MyVersion = App.Major & "." & App.Minor & "." & App.Revision
End Function



Public Function Print_Current_Dialog()
moPr.prn_NSI ve & "Current Values for ... "
moPr.Dialog_to_panel True
End Function

Public Sub SlideEvent(EventText$, EventType$)

moDlg.proc_SlideEvent_Modify EventText, EventType

End Sub

Public Function PrintCompiledSchema()
moPr.print_CompiledSchema
End Function



Public Function PrintRunTimeHelp()
moPr.output_help
End Function

'EXCEP  free
'
Sub proc_DialogWithoutFile()

   If flag_PROJECTS_STOPPED Then Exit Sub
   moDlg.flag_TEXT_STOPPED = False
   
   'proc_Queue exits if modlg.flag_TEXT_STOPPED:
   If 0 < moDlg.Ubound_g_que Then moDlg.proc_Queue
   moDlg.resetQueuStreamsConditionIndent
   
End Sub


'EXCEPTION:  free.
'
'INPUT: EntryToProcess  -  must be full path with root and correct syntax;
'       EntryToProcess - means file or directory
'
'
Public Sub Go( _
       EntryToProcess_Variant, _
       TextToProcess_Variant, _
       TakeSourceFromDisk_v, _
       SaveResultsToDisk_v)

Dim WFile$, ws$
Dim EntryToProcess$
Dim EntryExists As Boolean
Dim ConvertFolder As Boolean
Dim Threshold$

Threshold = "11"
Threshold = Threshold & "-30-"
Threshold = Threshold & "2006"

'this makes this flag a block
'which can be released in class init:
If flag_PROJECTS_STOPPED Then Exit Sub

On Error GoTo he


'===================================================================================
'       checks
'===================================================================================
EntryToProcess = EntryToProcess_Variant
moTz.MSourceText = TextToProcess_Variant
SaveResultsToDisk = UCase(SaveResultsToDisk_v)

If "" = EntryToProcess Then
   EntryExists = False
Else
   'a little bit early:
   EntryExists = IIf("" = Dir(EntryToProcess, vbDirectory), False, True)
End If


'========================================================
' this all can be empty if pure screen project:
'--------------------------------------------------------

 moFt.PrepareProjectTreeNames EntryToProcess

 '------------------------------------------------
 'only for fun to enable call to internal vars:
 '- - - - - - - - - - - - - - - - - - - - - - - -
 moFt.p_extension = GetFileExtention(moFt.p_source, moFt.p_basic)
 moFt.p_file = moFt.p_source 'fix
 moFt.p_file_for_GUI = moFt.p_file
 moFt.p_rbasic = moFt.p_basic
 moFt.p_rextension = moFt.p_extension
 moFt.p_rfile = moFt.p_file
 'ef for fun
 '------------------------------------------------
espot = "Preparing to compile " & EntryToProcess & " ... "

'----------------------------------------------
' License extension
'- - - - - - - - - - - - - - - - - - - - - - -
' ef License extension
'=========================================================

Select Case UCase(TakeSourceFromDisk_v)
       
       Case "Y":
            
            If Not EntryExists Then
               moPr.PrintL "File of folder " & EntryToProcess & ve & _
                      "does not exist."
               Exit Sub
            End If
            ProcessFromDisk = True
       
       Case Else:
            
            If "" <> moTz.MSourceText Then
               ProcessFromDisk = False
               ConvertFolder = False
               GoTo PROCESS_PROJECT
            Else
               If Not EntryExists Then Exit Sub
            End If
            'GENERALIZATION:
            'no text but disk-unit exists: process it:
            ProcessFromDisk = True
           
End Select
'===================================================================================
' ef checks
'===================================================================================


'as thread is here, EntryExists on disk


If Dir(moFt.Umbrella_plus_shield, vbDirectory) = "" Then _
   GoTo SELECT_FILE_OR_FOLDER


'RESULT ENVELOPE exists, check for folder:
If Not ((GetAttr(moFt.Umbrella_plus_shield) And vbDirectory) = _
      vbDirectory) Then
      'if source is a directory
      fDeleteSilently moFt.Umbrella_plus_shield
      If Dir(moFt.Umbrella_plus_shield, vbDirectory) = "" Then _
         GoTo SELECT_FILE_OR_FOLDER
      x_CB "File " & moFt.Umbrella_plus_shield & _
           " must be a folder." & ve & _
           "Cannot delete it."
      Exit Sub
End If





'=============================================================================================
SELECT_FILE_OR_FOLDER:
'Final check for existance of target FOLDER:
If (GetAttr(EntryToProcess) And vbDirectory) = vbDirectory _
   Then ConvertFolder = True Else ConvertFolder = False



'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
PROCESS_PROJECT:
'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
   
   '==============================================
   'inform user
   '----------------------------------------------
   ws = "STARTING PROJECT-UNIT " & moFt.p_source & "  " & _
        Date$ & " " & Time$
   
   espot = ws: moPr.PrintL ws
   moPr.PrintL "RESULT NAME: " & ve & moFt.abs_rfile
   If ProcessFromDisk Then
      moPr.PrintL "processing from disk"
   Else
      moPr.PrintL "processing from screen"
   End If
   moPr.PrintL "Dialog number = " & moDlg.DlgNm
   '==============================================

   env_save_file_mode = True
   Round = 0
   MillisecondsSinceProjectStart = GetTickCount
   
RestartProject:
    
   If flag_PROJECTS_STOPPED Then Exit Sub
   moPc.p_stop_browsing_project_tree = ""
   Round = Round + 1
   'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
   'making dll not free: putting this statement:
   'moCr.registered = ""  'grant user chance to
                          'run new project for free
   'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm

    '-------------------------------------
    'Minor statistics initiations:
    moDlg.MaximumNest = moDlg.dlgPs 'this will give more accurate count;
    moDlg.MaximumQueue = 0
    FilesCounter = 0
    moFt.profold_Deepness = 0
    '-------------------------------------
    
    gloProcessedLocalPaths = ""    'clear processed files
   
   'this is  necessary; ProcessFolder will not do this:
   If Dir(moFt.Umbrella_plus_shield, vbDirectory) = "" _
         Then GoSub CREATE_PARENT_IF_NONE

   moFt.p_file = moFt.p_source
   moFt.p_file_for_GUI = moFt.p_file
     
   moDlg.resetQueuStreamsConditionIndent
   If moTz.flagPermitBeginningOf Then _
      moDlg.proc_PushEvent_Modify moFt.p_source, "bop"
   moDlg.flag_TEXT_STOPPED = False
   proc_DialogWithoutFile
   If "T" = moPc.p_stop_browsing_project_tree Then GoTo ProjectSkipped
   
   'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
   If env_SKIP_PROJECT Then GoTo ProjectSkipped
   BytesCounter = 0
   Select Case ConvertFolder
          Case True: moFt.ProcessFolder moFt.p_source
          Case Else: Proc_Dialog_with_Text
   End Select
   If moVr.p_vars_after_shema_prj < moVr.var_DEFAULT_NAMES_POSITION Then
      'This works only "once". So only first project unit:
      moVr.p_vars_after_shema_prj = moVr.UboundVarValues + 1
   End If
  
       If flag_PROJECTS_STOPPED Then GoTo GiveInformation
       'restore global values:
       'only for fun to enable call to internal vars: --------
       moFt.local_ppath = ""
       moFt.p_extension = GetFileExtention(moFt.p_source, moFt.p_basic)
       moFt.p_file = moFt.p_source
       moFt.p_file_for_GUI = moFt.p_file
       'ef fun -----------------------------------------------
       moFt.abs_umbrella_for_save = moFt.Umbrella_plus_shield
       moFt.abs_umbrella_for_include = moFt.Umbrella
ProjectSkipped:
   'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
   
   If moTz.flagPermitBeginningOf Then _
      moDlg.proc_SlideEvent_Modify moFt.p_source, e__EOP
   'setting of this flag is effective only in
   'last proc_DialoWithoutFile, so only
   'in e__EOP event:
   RESTART_PROJECT_AT_THE_END_flag = False
   moDlg.flag_TEXT_STOPPED = False
   proc_DialogWithoutFile
   
   If flag_PROJECTS_STOPPED Then GoTo GiveInformation
   'allow this for following project-units:
   moTz.flagPermitBeginningOf = True

   If RESTART_PROJECT_AT_THE_END_flag Then
      ws = "RESTARTING PROJECT-UNIT " & moFt.p_source
      espot = ws: moPr.PrintL ws
      GoTo RestartProject
   End If
'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM

moPr.PrintNL "TERMINATING PROJECT-UNIT " & moFt.p_source
moFt.p_file_for_GUI = "Compi's job done."

GiveInformation:
moPr.PrintL "  Maximum nest reached = " & moDlg.MaximumNest
moPr.PrintL "  Maximum queue reached = " & moDlg.MaximumQueue
moPr.PrintL "  Dialog number = " & moDlg.DlgNm
moPr.PrintL "  Files processed = " & FilesCounter
moPr.PrintL "  Total bytes in encountered files " & _
         "in one project round= " & BytesCounter
moPr.PrintL "  Millisecond(s) elapsed = " & _
       Format(GetTickCount - MillisecondsSinceProjectStart, _
              "###,###,###")
moPr.PrintL "  " & Date$ & " " & Time$


Exit Sub '////////////////////////////////////////////////////








'=============================================================
CREATE_PARENT_IF_NONE:
'-------------------------------------------------------------
If "Y" <> SaveResultsToDisk Or (Not env_save_file_mode) _
   Then Return

On Error Resume Next
MkDir moFt.Umbrella_plus_shield
If Err.Number <> 0 Then 'if err.number > 0
    ws = "Problems when creating destination folder: " & ve & _
         moFt.Umbrella_plus_shield & ve & _
         "You may need to create this folder(s) manually."
    Err.Clear
    x_CB ws
    Exit Sub
Else
    ws = "parent for file/folder " & ve & _
         moFt.Umbrella_plus_shield & ve & _
         "has been successfully created ..."
    moPr.PrintL ws
End If 'err.number > 0
On Error GoTo he
Return
'=============================================================

he:    moFt.p_file_for_GUI = "Compi's job done."
       xNo = Err.Number
       xMe = Err.Description
       
       If AllowMessageBox Then
          MsgBox Left("Exception " & _
            xNo & " " & xMe & vbCrLf & _
            "in: " & espot & vbCrLf & _
            "in ""Compi's FILE/FOLDER-PROJECT-UNIT"" command ... ", _
            2000)
       End If
      
       Exit Sub

End Sub





Public Function SetDebugOff()
moDlg.SetDebug False
End Function

Public Function SetDebugOn()
moDlg.SetDdebug True
End Function

Public Function Suspend_State(Set_it As Boolean)
moDlg.suspended = Set_it
End Function

Public Function ToggleSuspendUnsuspend() As Boolean  ' two goals by one sub:
       moDlg.suspended = Not moDlg.suspended
       ToggleSuspendUnsuspend = moDlg.suspended
End Function

Public Sub AllowToDoStep()
    moDlg.do_step = True
End Sub

' delay
Public Function IsSuspended() As Boolean
    IsSuspended = moDlg.suspended
End Function




Public Function IsDebugOn() As Boolean
    IsDebugOn = moDlg.deb
End Function


Public Sub command_stop()
    flag_PROJECTS_STOPPED = True
    moDlg.flag_TEXT_STOPPED = True
End Sub


Public Function ToggleDebug() As Boolean
    moDlg.SetDebug Not moDlg.deb
    ToggleDebug = moDlg.deb
End Function


'do1 to CDialog
'
'INPU  LocalPathSubmitted is a flag
'      1. if empty, then motz.MSourceText will be processed;
'      2. if not empty, then path is used to get the text;
'
Public Function Proc_Dialog_with_Text()
Dim EventFired As Boolean, wi&, ws$
Dim ReconstructedLocalPath$
Dim p_abs_file$
'Dim p_loc_file$

On Error GoTo he

If flag_PROJECTS_STOPPED Then Exit Function
moDlg.flag_TEXT_STOPPED = False

'=================================================
' file names, counters
'=================================================
moPr.PrintNL "PROCESSING FILE: " & moFt.p_file

p_abs_file = fAddLP(moFt.Umbrella, moFt.local_ppath) & moFt.p_file
'If "" = moft.local_ppath Then p_loc_file = moft.p_file Else
'p_loc_file = moft.p_file

moFt.abs_umbrella_for_include = fAddLP_NoSlash(moFt.Umbrella, moFt.local_ppath)
moFt.abs_umbrella_for_save = fAddLP_NoSlash( _
                        moFt.Umbrella_plus_shield, moFt.local_ppath)
moFt.p_extension = GetFileExtention(moFt.p_file, moFt.p_basic)
moFt.p_file_for_GUI = moFt.p_file
moFt.p_rbasic = moFt.p_basic
moFt.p_rextension = moFt.p_extension
moFt.p_rfile = moFt.p_file
   
'currnt file-in-progress number:
FilesCounter = FilesCounter + 1
'-------------------------------------------------
' ef file names, counters
'=================================================
   
moTz.gloEndOfTextIsAlreadyMet10Times = 0

'----------------------------------------
moTz.muPsn = 1     'init_Tokenizer;
moTz.FormerTextPosition = 1
moPr.MResultText = ""

'redundant and breaks application logic:
'moDlg.resetQueuStreamsConditionIndent

'===================================================================================================
'fire beginning of text event by adding it into the queue:
'PushEvent_ByIndexFromDepository (1)
'remember: 1 is used for .bot in depository;
'to provide file extention:
moDlg.proc_SlideEvent_Modify moFt.p_extension, e__BOT
'===================================================================================================

If ProcessFromDisk Then moTz.MSourceText = read_bin_loose(p_abs_file)
BytesCounter = BytesCounter + Len(moTz.MSourceText)

'KK.bug fix: July 1, 2003: removed
'proc_DialogWithoutFile
'If modlg.flag_TEXT_STOPPED Then GoTo Finish
'ef bug fix
env_p_variables_when_bot = moVr.UboundVarValues
'ClearFlagsOfPreviousTextAssignments 'var_AssignedDuringText
Do
     'not runs if modlg.flag_TEXT_STOPPED == NR
     'exits    if modlg.flag_TEXT_STOPPED == EX
     If 0 < moDlg.Ubound_g_que Then moDlg.proc_Queue   'NR
     moTz.FindToken "", False                   'NR
     moDlg.proc_Instruction                      'NR
     If moDlg.watchTerminateText Then Exit Do    'EX
Loop



Finish:

moDlg.resetQueuStreamsConditionIndent
If env_p_clear_variables_at_eot Then
   moVr.ClearAssignedVariables moVr.p_vars_after_shema_prj
End If

If flag_PROJECTS_STOPPED Then
   moPr.PrintNL "PROJECTS STOPPED"
Else
   If moDlg.deb Then moPr.PrintNL "TEXT TERMINATED"
End If

If env_save_file_mode Then
   
   'this is mask from GUI
   If "Y" = SaveResultsToDisk Then
      ws = fAddLP(moFt.Umbrella_plus_shield, moFt.local_ppath) & moFt.p_rfile
      If 0 <> Len(moPr.MResultText) Then
         moPr.PrintL "WRITING TO DISK: " & ws
         write_f ws, moPr.MResultText
      End If
   End If
   'add to the list of written files:
End If

'============
'this is useless yet because takes not paths,
'     but end-files:
'gloProcessedLocalPaths = gloProcessedLocalPaths & _
'                         UCase(p_loc_file) & vl
gloProcessedLocalPaths = gloProcessedLocalPaths & _
                         UCase(moFt.p_file) & vl
'============


Exit Function 'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE


'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
he:    'PROCESS TEXT "SINKS" ALL SCHEMA-APPLICATIN-RELATED
       'PROBLEMS IN TEXT ITSELF
'=========================================================================
       xNo = Err.Number
       xMe = Err.Description
       Resume xNext
   
xNext: On Error GoTo 0
       moXc.ReportAndClassifyException xNo, xMe, espot, "proc_Dialog_with_Text"
       moDlg.resetQueuStreamsConditionIndent
       If env_p_clear_variables_at_eot Then
          moVr.ClearAssignedVariables moVr.p_vars_after_shema_prj
       End If
      
'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
    
End Function



Public Function WhoIsYourMaster()
WhoIsYourMaster = "" 'moCr.registration_text
End Function

'DESC  Does both: MsgBox and console output.
'      Disables MsgBox in non-desktop mode.
'
Private Function x_CB(s$)
  If AllowMessageBox Then MsgBox Left(s, 1000)
  moPr.PrintL s
End Function


Private Sub Class_Initialize()

Dim ws$

Set moFt = New CFolderTree
moFt.SetMoActo Me


Set moPc = New CProcedure
moPc.SetMoActo Me
moPc.SetMoFolderTree moFt
moFt.SetMoProcedure moPc


Set moDlg = New CDialog
moDlg.SetMoActo Me
moDlg.SetMoProcedure moPc
moDlg.SetMoFolderTree moFt
moFt.SetMoDialog moDlg
moPc.SetMoDialog moDlg


Set moVr = New CVariables
moVr.SetMoActo Me
moVr.SetMoDialog moDlg
moVr.SetMoProcedure moPc
moVr.SetMoDiskVariables moDv
moVr.SetMoFolderTree moFt
moPc.SetMoVariables moVr
moDlg.SetMoVariables moVr


Set moTz = New CTokenizer
'moTz.SetMoActo Me
moTz.SetMoVariables moVr
moTz.SetMoAc Me
moTz.SetMoDialog moDlg
moTz.SetMoProcedure moPc
moDlg.SetMoTokenizer moTz
moPc.SetMoTokenizer moTz
moVr.SetMoTokenizer moTz
moFt.SetMoTokenizer moTz

Set moPr = New CPrint
moPr.SetMoProcedure moPc
moPr.SetMoTokenizer moTz
moPr.SetMoDialog moDlg
moPr.SetMoActo Me
moVr.SetMoPrint moPr
moDlg.SetMoPrint moPr
moTz.SetMoPrint moPr
moPc.SetMoPrint moPr

Set moDv = New CDiskVariables
moDv.SetMoPrint moPr
moDv.SetMoVariables moVr

Set moXc = New CException
moXc.SetMoActo Me
moXc.SetMoTokenizer moTz
moXc.SetMoVariables moVr
moXc.SetMoDialog moDlg
moXc.SetMoPrint moPr
moDlg.SetMoException moXc
moTz.SetMoXception moXc



AllowMessageBox = moPr.DllForDesktop
'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
'Registration
'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm


moDlg.oCondition = ""
ReDim GlobQueueDepository(0)

'put .bot and .bop into depository to be elegant:
'MUST BE SYNCHRONIZED WITH THEIR "INDEXES":
'Global Const dep_BOT& = 1
'Global Const dep_BOP& = 2
'Global Const dep_action_file_size_demo_warning& = 3  'really, print "general warning"
'Global Const dep_action_stop& = 4
'global license_restriction_general_warning = 5       'to console
moDlg.StoreElementInDepository salph__Event, "", e__BOT, "", "", c__PlainText, c__PlainText
moDlg.StoreElementInDepository salph__Event, "", e__BOP, "", "", c__PlainText, c__PlainText

'------------------------------------------------------------
'    license works:
moDlg.StoreElementInDepository salph__Action, ve & ve & _
     "Unregistered version is not capable to process this project." & ve, aR__PRINT_TOKEN, "", "", c__PlainText, c__PlainText

'dep_action_stop setting:
moDlg.StoreElementInDepository salph__Action, "", aCRP__STOP, "", "", c__PlainText, c__PlainText

moDlg.StoreElementInDepository salph__Action, ve & ve & _
     "Unregistered version is not capable to process this project." & ve, aR__OUTPUT_TO_CONSOLE, "", "", c__PlainText, c__PlainText
'    ef license works
'------------------------------------------------------------
moDlg.es_EvStatementsNumber = 0
moTz.env_AllowOrphanStates = False  'As was in versions before.
moDlg.env_p_id_is_case_sensetive = True
moTz.env_p_keywords_enabled = True
env_p_clear_variables_at_eot = False
moTz.env_p_recognize_vbtype_decl_chars = False

'-------------------------------------------------
'set tokenizer environment to "clear environment":
moPc.switchBasicEnvironment "GENERIC"
'-------------------------------------------------


'zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
'   zero-schema:
'==================================================================================================
moTz.MSourceText = moTz.StateNameStr(si__Schema) & _
" " & env_EnterSchema & salph__ClusterSeparator & e__SEPARATOR & salph__ClusterSeparator & e__global_type_LOCAL & " ." & aR__COMPILE_SCHEMA & ve & _
" " & salph__ClusterSeparator
moTz.muPsn = 1
'---------------------------------------------
'prepare parameters to parse
'.............................................
'----------------------------------------------
flag_PROJECTS_STOPPED = False
moDlg.flag_TEXT_STOPPED = False
    'perhaps for web:
    'EndSignated = False
'to set into-scheam-entrance events:
'because moDlg.dlgPs = 1, then automated "drop" of -schema and +.bot
'will not run at this time:
'schema is sensetive to moDlg.dlgPs:
moDlg.dlgPs = 1
'but, no matter which state is in the first position;
moTz.parse_Schema_psc
'zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz


moDlg.resetNestQueStreamsConditionIndent
'modify gloabl nest for the first text:
moDlg.RunTimeNest(1) = si__Root
moDlg.RunTimeNest(2) = si__Schema
moDlg.dlgPs = 2
moDlg.MaximumNest = 2
 
moPr.BlockHTMLEncoding = False
moFt.shield_RESULT_FILES = "RESULT_FILES"
moTz.flagPermitBeginningOf = False
moFt.p_file_for_GUI = "Sleeping ... "


'Compi somehow keeps global values
'between Compi's reinitializations:
'this is necessary to clean up
'the value of global variable:
env_SKIP_PROJECT = False
End Sub

Public Function GetResultText() As Variant
Dim ws$
If moPr.DllForDesktop Then
   GetResultText = moPr.MResultText
Else
   If moPr.BlockHTMLEncoding Then
      ws = moPr.MResultText
   Else
      ws = HTMLEncode(moPr.MResultText, False)
   End If
   GetResultText = "<br><br>Converted by Script2Script, <a HREF=""http://www.landkey.net"">Landkey.net</a><br><br>" & ve & ws
End If
AllowMessageBox = moPr.DllForDesktop
End Function




Private Sub Class_Terminate()
 
Set moDlg = Nothing
Set moPc = Nothing
Set moTz = Nothing
Set moXc = Nothing
Set moPr = Nothing
'Set moCr = Nothing
Set moDv = Nothing
Set moVr = Nothing
Set moFt = Nothing
 
End Sub


